/** ********************************
 * AuthService interface and hook.
 ** ******************************** */
export interface UsernameAndPassword {
    username: string;
    password: string;
}
export interface AuthService {
    isOidcAuthEnabled: () => boolean;
    isBasicAuthEnabled: () => boolean;
    isAuthenticated: () => Promise<boolean>;
    getUsername: () => Promise<string | undefined>;
    getToken: () => Promise<string | undefined>;
    getUsernameAndPassword: () => UsernameAndPassword | undefined;
    login: (username: string, password: string) => Promise<void>;
    logout: () => Promise<void>;
}
/**
 * React hook to get the application Auth service.
 */
export declare const useAuth: () => AuthService;
