import j, { createContext as gt, useContext as ut, useState as I, useEffect as Te, memo as Ie, forwardRef as ee, useCallback as Ne, useMemo as qe } from "react";
import { jsx as a, jsxs as f, Fragment as ae } from "react/jsx-runtime";
import { EmptyState as te, EmptyStateVariant as _t, EmptyStateHeader as se, EmptyStateBody as ue, Spinner as X, Alert as pt, Dropdown as ft, MenuToggle as ce, DropdownList as mt, Divider as Je, DropdownItem as wt, Select as Ee, SelectOption as Ce, TextInput as _e, Button as pe, TextArea as vt, Modal as Re, Form as St, FormGroup as je, EmptyStateIcon as Be, AboutModal as bt, TextContent as yt, Text as He, TextVariants as Le, TextList as Me, TextListItem as y, Progress as kt, Pagination as Tt, PaginationVariant as It, Skeleton as Et, SearchInput as Ct, SelectList as Rt, ToolbarItem as xt, InputGroup as Ut, ToolbarToggleGroup as At, ToolbarGroup as Pt, ToolbarFilter as Ot } from "@patternfly/react-core";
import { EllipsisVIcon as Nt, ChevronDownIcon as qt, ChevronRightIcon as jt, ErrorCircleOIcon as Ht, FilterIcon as Ve } from "@patternfly/react-icons";
import { DateTime as de } from "luxon";
import { Tr as ie, Td as xe, Th as Lt, Table as Mt, Thead as Ft, Tbody as Dt, ActionsColumn as $t } from "@patternfly/react-table";
import Wt from "use-resize-observer";
const Kt = gt({
  type: "none"
});
class V extends Error {
}
V.prototype.name = "InvalidTokenError";
function zt(e) {
  return decodeURIComponent(atob(e).replace(/(.)/g, (t, s) => {
    let i = s.charCodeAt(0).toString(16).toUpperCase();
    return i.length < 2 && (i = "0" + i), "%" + i;
  }));
}
function Jt(e) {
  let t = e.replace(/-/g, "+").replace(/_/g, "/");
  switch (t.length % 4) {
    case 0:
      break;
    case 2:
      t += "==";
      break;
    case 3:
      t += "=";
      break;
    default:
      throw new Error("base64 string is not of the correct length");
  }
  try {
    return zt(t);
  } catch {
    return atob(t);
  }
}
function Bt(e, t) {
  if (typeof e != "string")
    throw new V("Invalid token specified: must be a string");
  t || (t = {});
  const s = t.header === !0 ? 0 : 1, i = e.split(".")[s];
  if (typeof i != "string")
    throw new V(`Invalid token specified: missing part #${s + 1}`);
  let r;
  try {
    r = Jt(i);
  } catch (n) {
    throw new V(`Invalid token specified: invalid base64 for part #${s + 1} (${n.message})`);
  }
  try {
    return JSON.parse(r);
  } catch (n) {
    throw new V(`Invalid token specified: invalid json for part #${s + 1} (${n.message})`);
  }
}
var Vt = {
  debug: () => {
  },
  info: () => {
  },
  warn: () => {
  },
  error: () => {
  }
}, N, q, re = /* @__PURE__ */ ((e) => (e[e.NONE = 0] = "NONE", e[e.ERROR = 1] = "ERROR", e[e.WARN = 2] = "WARN", e[e.INFO = 3] = "INFO", e[e.DEBUG = 4] = "DEBUG", e))(re || {});
((e) => {
  function t() {
    N = 3, q = Vt;
  }
  e.reset = t;
  function s(r) {
    if (!(0 <= r && r <= 4))
      throw new Error("Invalid log level");
    N = r;
  }
  e.setLevel = s;
  function i(r) {
    q = r;
  }
  e.setLogger = i;
})(re || (re = {}));
var u = class O {
  constructor(t) {
    this._name = t;
  }
  /* eslint-disable @typescript-eslint/no-unsafe-enum-comparison */
  debug(...t) {
    N >= 4 && q.debug(O._format(this._name, this._method), ...t);
  }
  info(...t) {
    N >= 3 && q.info(O._format(this._name, this._method), ...t);
  }
  warn(...t) {
    N >= 2 && q.warn(O._format(this._name, this._method), ...t);
  }
  error(...t) {
    N >= 1 && q.error(O._format(this._name, this._method), ...t);
  }
  /* eslint-enable @typescript-eslint/no-unsafe-enum-comparison */
  throw(t) {
    throw this.error(t), t;
  }
  create(t) {
    const s = Object.create(this);
    return s._method = t, s.debug("begin"), s;
  }
  static createStatic(t, s) {
    const i = new O(`${t}.${s}`);
    return i.debug("begin"), i;
  }
  static _format(t, s) {
    const i = `[${t}]`;
    return s ? `${i} ${s}:` : i;
  }
  /* eslint-disable @typescript-eslint/no-unsafe-enum-comparison */
  // helpers for static class methods
  static debug(t, ...s) {
    N >= 4 && q.debug(O._format(t), ...s);
  }
  static info(t, ...s) {
    N >= 3 && q.info(O._format(t), ...s);
  }
  static warn(t, ...s) {
    N >= 2 && q.warn(O._format(t), ...s);
  }
  static error(t, ...s) {
    N >= 1 && q.error(O._format(t), ...s);
  }
  /* eslint-enable @typescript-eslint/no-unsafe-enum-comparison */
};
re.reset();
var Gt = "10000000-1000-4000-8000-100000000000", Fe = (e) => btoa([...new Uint8Array(e)].map((t) => String.fromCharCode(t)).join("")), z = class G {
  static _randomWord() {
    const t = new Uint32Array(1);
    return crypto.getRandomValues(t), t[0];
  }
  /**
   * Generates RFC4122 version 4 guid
   */
  static generateUUIDv4() {
    return Gt.replace(
      /[018]/g,
      (s) => (+s ^ G._randomWord() & 15 >> +s / 4).toString(16)
    ).replace(/-/g, "");
  }
  /**
   * PKCE: Generate a code verifier
   */
  static generateCodeVerifier() {
    return G.generateUUIDv4() + G.generateUUIDv4() + G.generateUUIDv4();
  }
  /**
   * PKCE: Generate a code challenge
   */
  static async generateCodeChallenge(t) {
    if (!crypto.subtle)
      throw new Error("Crypto.subtle is available only in secure contexts (HTTPS).");
    try {
      const i = new TextEncoder().encode(t), r = await crypto.subtle.digest("SHA-256", i);
      return Fe(r).replace(/\+/g, "-").replace(/\//g, "_").replace(/=+$/, "");
    } catch (s) {
      throw u.error("CryptoUtils.generateCodeChallenge", s), s;
    }
  }
  /**
   * Generates a base64-encoded string for a basic auth header
   */
  static generateBasicAuth(t, s) {
    const r = new TextEncoder().encode([t, s].join(":"));
    return Fe(r);
  }
}, F = class {
  constructor(e) {
    this._name = e, this._logger = new u(`Event('${this._name}')`), this._callbacks = [];
  }
  addHandler(e) {
    return this._callbacks.push(e), () => this.removeHandler(e);
  }
  removeHandler(e) {
    const t = this._callbacks.lastIndexOf(e);
    t >= 0 && this._callbacks.splice(t, 1);
  }
  async raise(...e) {
    this._logger.debug("raise:", ...e);
    for (const t of this._callbacks)
      await t(...e);
  }
}, fe = class {
  // IMPORTANT: doesn't validate the token
  static decode(e) {
    try {
      return Bt(e);
    } catch (t) {
      throw u.error("JwtUtils.decode", t), t;
    }
  }
}, De = class {
  /**
   * Populates a map of window features with a placement centered in front of
   * the current window. If no explicit width is given, a default value is
   * binned into [800, 720, 600, 480, 360] based on the current window's width.
   */
  static center({ ...e }) {
    var t, s, i;
    return e.width == null && (e.width = (t = [800, 720, 600, 480].find((r) => r <= window.outerWidth / 1.618)) != null ? t : 360), (s = e.left) != null || (e.left = Math.max(0, Math.round(window.screenX + (window.outerWidth - e.width) / 2))), e.height != null && ((i = e.top) != null || (e.top = Math.max(0, Math.round(window.screenY + (window.outerHeight - e.height) / 2)))), e;
  }
  static serialize(e) {
    return Object.entries(e).filter(([, t]) => t != null).map(([t, s]) => `${t}=${typeof s != "boolean" ? s : s ? "yes" : "no"}`).join(",");
  }
}, M = class Z extends F {
  constructor() {
    super(...arguments), this._logger = new u(`Timer('${this._name}')`), this._timerHandle = null, this._expiration = 0, this._callback = () => {
      const t = this._expiration - Z.getEpochTime();
      this._logger.debug("timer completes in", t), this._expiration <= Z.getEpochTime() && (this.cancel(), super.raise());
    };
  }
  // get the time
  static getEpochTime() {
    return Math.floor(Date.now() / 1e3);
  }
  init(t) {
    const s = this._logger.create("init");
    t = Math.max(Math.floor(t), 1);
    const i = Z.getEpochTime() + t;
    if (this.expiration === i && this._timerHandle) {
      s.debug("skipping since already initialized for expiration at", this.expiration);
      return;
    }
    this.cancel(), s.debug("using duration", t), this._expiration = i;
    const r = Math.min(t, 5);
    this._timerHandle = setInterval(this._callback, r * 1e3);
  }
  get expiration() {
    return this._expiration;
  }
  cancel() {
    this._logger.create("cancel"), this._timerHandle && (clearInterval(this._timerHandle), this._timerHandle = null);
  }
}, me = class {
  static readParams(e, t = "query") {
    if (!e)
      throw new TypeError("Invalid URL");
    const i = new URL(e, "http://127.0.0.1")[t === "fragment" ? "hash" : "search"];
    return new URLSearchParams(i.slice(1));
  }
}, we = ";", W = class extends Error {
  constructor(e, t) {
    var s, i, r;
    if (super(e.error_description || e.error || ""), this.form = t, this.name = "ErrorResponse", !e.error)
      throw u.error("ErrorResponse", "No error passed"), new Error("No error passed");
    this.error = e.error, this.error_description = (s = e.error_description) != null ? s : null, this.error_uri = (i = e.error_uri) != null ? i : null, this.state = e.userState, this.session_state = (r = e.session_state) != null ? r : null, this.url_state = e.url_state;
  }
}, Ue = class extends Error {
  constructor(e) {
    super(e), this.name = "ErrorTimeout";
  }
}, Qt = class {
  constructor(e) {
    this._logger = new u("AccessTokenEvents"), this._expiringTimer = new M("Access token expiring"), this._expiredTimer = new M("Access token expired"), this._expiringNotificationTimeInSeconds = e.expiringNotificationTimeInSeconds;
  }
  load(e) {
    const t = this._logger.create("load");
    if (e.access_token && e.expires_in !== void 0) {
      const s = e.expires_in;
      if (t.debug("access token present, remaining duration:", s), s > 0) {
        let r = s - this._expiringNotificationTimeInSeconds;
        r <= 0 && (r = 1), t.debug("registering expiring timer, raising in", r, "seconds"), this._expiringTimer.init(r);
      } else
        t.debug("canceling existing expiring timer because we're past expiration."), this._expiringTimer.cancel();
      const i = s + 1;
      t.debug("registering expired timer, raising in", i, "seconds"), this._expiredTimer.init(i);
    } else
      this._expiringTimer.cancel(), this._expiredTimer.cancel();
  }
  unload() {
    this._logger.debug("unload: canceling existing access token timers"), this._expiringTimer.cancel(), this._expiredTimer.cancel();
  }
  /**
   * Add callback: Raised prior to the access token expiring.
   */
  addAccessTokenExpiring(e) {
    return this._expiringTimer.addHandler(e);
  }
  /**
   * Remove callback: Raised prior to the access token expiring.
   */
  removeAccessTokenExpiring(e) {
    this._expiringTimer.removeHandler(e);
  }
  /**
   * Add callback: Raised after the access token has expired.
   */
  addAccessTokenExpired(e) {
    return this._expiredTimer.addHandler(e);
  }
  /**
   * Remove callback: Raised after the access token has expired.
   */
  removeAccessTokenExpired(e) {
    this._expiredTimer.removeHandler(e);
  }
}, Xt = class {
  constructor(e, t, s, i, r) {
    this._callback = e, this._client_id = t, this._intervalInSeconds = i, this._stopOnError = r, this._logger = new u("CheckSessionIFrame"), this._timer = null, this._session_state = null, this._message = (c) => {
      c.origin === this._frame_origin && c.source === this._frame.contentWindow && (c.data === "error" ? (this._logger.error("error message from check session op iframe"), this._stopOnError && this.stop()) : c.data === "changed" ? (this._logger.debug("changed message from check session op iframe"), this.stop(), this._callback()) : this._logger.debug(c.data + " message from check session op iframe"));
    };
    const n = new URL(s);
    this._frame_origin = n.origin, this._frame = window.document.createElement("iframe"), this._frame.style.visibility = "hidden", this._frame.style.position = "fixed", this._frame.style.left = "-1000px", this._frame.style.top = "0", this._frame.width = "0", this._frame.height = "0", this._frame.src = n.href;
  }
  load() {
    return new Promise((e) => {
      this._frame.onload = () => {
        e();
      }, window.document.body.appendChild(this._frame), window.addEventListener("message", this._message, !1);
    });
  }
  start(e) {
    if (this._session_state === e)
      return;
    this._logger.create("start"), this.stop(), this._session_state = e;
    const t = () => {
      !this._frame.contentWindow || !this._session_state || this._frame.contentWindow.postMessage(this._client_id + " " + this._session_state, this._frame_origin);
    };
    t(), this._timer = setInterval(t, this._intervalInSeconds * 1e3);
  }
  stop() {
    this._logger.create("stop"), this._session_state = null, this._timer && (clearInterval(this._timer), this._timer = null);
  }
}, Ge = class {
  constructor() {
    this._logger = new u("InMemoryWebStorage"), this._data = {};
  }
  clear() {
    this._logger.create("clear"), this._data = {};
  }
  getItem(e) {
    return this._logger.create(`getItem('${e}')`), this._data[e];
  }
  setItem(e, t) {
    this._logger.create(`setItem('${e}')`), this._data[e] = t;
  }
  removeItem(e) {
    this._logger.create(`removeItem('${e}')`), delete this._data[e];
  }
  get length() {
    return Object.getOwnPropertyNames(this._data).length;
  }
  key(e) {
    return Object.getOwnPropertyNames(this._data)[e];
  }
}, Ae = class {
  constructor(e = [], t = null, s = {}) {
    this._jwtHandler = t, this._extraHeaders = s, this._logger = new u("JsonService"), this._contentTypes = [], this._contentTypes.push(...e, "application/json"), t && this._contentTypes.push("application/jwt");
  }
  async fetchWithTimeout(e, t = {}) {
    const { timeoutInSeconds: s, ...i } = t;
    if (!s)
      return await fetch(e, i);
    const r = new AbortController(), n = setTimeout(() => r.abort(), s * 1e3);
    try {
      return await fetch(e, {
        ...t,
        signal: r.signal
      });
    } catch (c) {
      throw c instanceof DOMException && c.name === "AbortError" ? new Ue("Network timed out") : c;
    } finally {
      clearTimeout(n);
    }
  }
  async getJson(e, {
    token: t,
    credentials: s
  } = {}) {
    const i = this._logger.create("getJson"), r = {
      Accept: this._contentTypes.join(", ")
    };
    t && (i.debug("token passed, setting Authorization header"), r.Authorization = "Bearer " + t), this.appendExtraHeaders(r);
    let n;
    try {
      i.debug("url:", e), n = await this.fetchWithTimeout(e, { method: "GET", headers: r, credentials: s });
    } catch (l) {
      throw i.error("Network Error"), l;
    }
    i.debug("HTTP response received, status", n.status);
    const c = n.headers.get("Content-Type");
    if (c && !this._contentTypes.find((l) => c.startsWith(l)) && i.throw(new Error(`Invalid response Content-Type: ${c ?? "undefined"}, from URL: ${e}`)), n.ok && this._jwtHandler && (c != null && c.startsWith("application/jwt")))
      return await this._jwtHandler(await n.text());
    let o;
    try {
      o = await n.json();
    } catch (l) {
      throw i.error("Error parsing JSON response", l), n.ok ? l : new Error(`${n.statusText} (${n.status})`);
    }
    if (!n.ok)
      throw i.error("Error from server:", o), o.error ? new W(o) : new Error(`${n.statusText} (${n.status}): ${JSON.stringify(o)}`);
    return o;
  }
  async postForm(e, {
    body: t,
    basicAuth: s,
    timeoutInSeconds: i,
    initCredentials: r
  }) {
    const n = this._logger.create("postForm"), c = {
      Accept: this._contentTypes.join(", "),
      "Content-Type": "application/x-www-form-urlencoded"
    };
    s !== void 0 && (c.Authorization = "Basic " + s), this.appendExtraHeaders(c);
    let o;
    try {
      n.debug("url:", e), o = await this.fetchWithTimeout(e, { method: "POST", headers: c, body: t, timeoutInSeconds: i, credentials: r });
    } catch (g) {
      throw n.error("Network error"), g;
    }
    n.debug("HTTP response received, status", o.status);
    const l = o.headers.get("Content-Type");
    if (l && !this._contentTypes.find((g) => l.startsWith(g)))
      throw new Error(`Invalid response Content-Type: ${l ?? "undefined"}, from URL: ${e}`);
    const d = await o.text();
    let h = {};
    if (d)
      try {
        h = JSON.parse(d);
      } catch (g) {
        throw n.error("Error parsing JSON response", g), o.ok ? g : new Error(`${o.statusText} (${o.status})`);
      }
    if (!o.ok)
      throw n.error("Error from server:", h), h.error ? new W(h, t) : new Error(`${o.statusText} (${o.status}): ${JSON.stringify(h)}`);
    return h;
  }
  appendExtraHeaders(e) {
    const t = this._logger.create("appendExtraHeaders"), s = Object.keys(this._extraHeaders), i = [
      "authorization",
      "accept",
      "content-type"
    ];
    s.length !== 0 && s.forEach((r) => {
      if (i.includes(r.toLocaleLowerCase())) {
        t.warn("Protected header could not be overridden", r, i);
        return;
      }
      const n = typeof this._extraHeaders[r] == "function" ? this._extraHeaders[r]() : this._extraHeaders[r];
      n && n !== "" && (e[r] = n);
    });
  }
}, Yt = class {
  constructor(e) {
    this._settings = e, this._logger = new u("MetadataService"), this._signingKeys = null, this._metadata = null, this._metadataUrl = this._settings.metadataUrl, this._jsonService = new Ae(
      ["application/jwk-set+json"],
      null,
      this._settings.extraHeaders
    ), this._settings.signingKeys && (this._logger.debug("using signingKeys from settings"), this._signingKeys = this._settings.signingKeys), this._settings.metadata && (this._logger.debug("using metadata from settings"), this._metadata = this._settings.metadata), this._settings.fetchRequestCredentials && (this._logger.debug("using fetchRequestCredentials from settings"), this._fetchRequestCredentials = this._settings.fetchRequestCredentials);
  }
  resetSigningKeys() {
    this._signingKeys = null;
  }
  async getMetadata() {
    const e = this._logger.create("getMetadata");
    if (this._metadata)
      return e.debug("using cached values"), this._metadata;
    if (!this._metadataUrl)
      throw e.throw(new Error("No authority or metadataUrl configured on settings")), null;
    e.debug("getting metadata from", this._metadataUrl);
    const t = await this._jsonService.getJson(this._metadataUrl, { credentials: this._fetchRequestCredentials });
    return e.debug("merging remote JSON with seed metadata"), this._metadata = Object.assign({}, this._settings.metadataSeed, t), this._metadata;
  }
  getIssuer() {
    return this._getMetadataProperty("issuer");
  }
  getAuthorizationEndpoint() {
    return this._getMetadataProperty("authorization_endpoint");
  }
  getUserInfoEndpoint() {
    return this._getMetadataProperty("userinfo_endpoint");
  }
  getTokenEndpoint(e = !0) {
    return this._getMetadataProperty("token_endpoint", e);
  }
  getCheckSessionIframe() {
    return this._getMetadataProperty("check_session_iframe", !0);
  }
  getEndSessionEndpoint() {
    return this._getMetadataProperty("end_session_endpoint", !0);
  }
  getRevocationEndpoint(e = !0) {
    return this._getMetadataProperty("revocation_endpoint", e);
  }
  getKeysEndpoint(e = !0) {
    return this._getMetadataProperty("jwks_uri", e);
  }
  async _getMetadataProperty(e, t = !1) {
    const s = this._logger.create(`_getMetadataProperty('${e}')`), i = await this.getMetadata();
    if (s.debug("resolved"), i[e] === void 0) {
      if (t === !0) {
        s.warn("Metadata does not contain optional property");
        return;
      }
      s.throw(new Error("Metadata does not contain property " + e));
    }
    return i[e];
  }
  async getSigningKeys() {
    const e = this._logger.create("getSigningKeys");
    if (this._signingKeys)
      return e.debug("returning signingKeys from cache"), this._signingKeys;
    const t = await this.getKeysEndpoint(!1);
    e.debug("got jwks_uri", t);
    const s = await this._jsonService.getJson(t);
    if (e.debug("got key set", s), !Array.isArray(s.keys))
      throw e.throw(new Error("Missing keys on keyset")), null;
    return this._signingKeys = s.keys, this._signingKeys;
  }
}, Qe = class {
  constructor({
    prefix: e = "oidc.",
    store: t = localStorage
  } = {}) {
    this._logger = new u("WebStorageStateStore"), this._store = t, this._prefix = e;
  }
  async set(e, t) {
    this._logger.create(`set('${e}')`), e = this._prefix + e, await this._store.setItem(e, t);
  }
  async get(e) {
    return this._logger.create(`get('${e}')`), e = this._prefix + e, await this._store.getItem(e);
  }
  async remove(e) {
    this._logger.create(`remove('${e}')`), e = this._prefix + e;
    const t = await this._store.getItem(e);
    return await this._store.removeItem(e), t;
  }
  async getAllKeys() {
    this._logger.create("getAllKeys");
    const e = await this._store.length, t = [];
    for (let s = 0; s < e; s++) {
      const i = await this._store.key(s);
      i && i.indexOf(this._prefix) === 0 && t.push(i.substr(this._prefix.length));
    }
    return t;
  }
}, Zt = "code", es = "openid", ts = "client_secret_post", ss = 60 * 15, ve = class {
  constructor({
    // metadata related
    authority: e,
    metadataUrl: t,
    metadata: s,
    signingKeys: i,
    metadataSeed: r,
    // client related
    client_id: n,
    client_secret: c,
    response_type: o = Zt,
    scope: l = es,
    redirect_uri: d,
    post_logout_redirect_uri: h,
    client_authentication: g = ts,
    // optional protocol
    prompt: v,
    display: b,
    max_age: R,
    ui_locales: k,
    acr_values: x,
    resource: E,
    response_mode: H,
    // behavior flags
    filterProtocolClaims: T = !0,
    loadUserInfo: w = !1,
    staleStateAgeInSeconds: U = ss,
    mergeClaimsStrategy: C = { array: "replace" },
    disablePKCE: S = !1,
    // other behavior
    stateStore: L,
    revokeTokenAdditionalContentTypes: B,
    fetchRequestCredentials: Y,
    refreshTokenAllowedScope: p,
    // extra
    extraQueryParams: m = {},
    extraTokenParams: P = {},
    extraHeaders: D = {}
  }) {
    if (this.authority = e, t ? this.metadataUrl = t : (this.metadataUrl = e, e && (this.metadataUrl.endsWith("/") || (this.metadataUrl += "/"), this.metadataUrl += ".well-known/openid-configuration")), this.metadata = s, this.metadataSeed = r, this.signingKeys = i, this.client_id = n, this.client_secret = c, this.response_type = o, this.scope = l, this.redirect_uri = d, this.post_logout_redirect_uri = h, this.client_authentication = g, this.prompt = v, this.display = b, this.max_age = R, this.ui_locales = k, this.acr_values = x, this.resource = E, this.response_mode = H, this.filterProtocolClaims = T ?? !0, this.loadUserInfo = !!w, this.staleStateAgeInSeconds = U, this.mergeClaimsStrategy = C, this.disablePKCE = !!S, this.revokeTokenAdditionalContentTypes = B, this.fetchRequestCredentials = Y || "same-origin", L)
      this.stateStore = L;
    else {
      const $ = typeof window < "u" ? window.localStorage : new Ge();
      this.stateStore = new Qe({ store: $ });
    }
    this.refreshTokenAllowedScope = p, this.extraQueryParams = m, this.extraTokenParams = P, this.extraHeaders = D;
  }
}, is = class {
  constructor(e, t) {
    this._settings = e, this._metadataService = t, this._logger = new u("UserInfoService"), this._getClaimsFromJwt = async (s) => {
      const i = this._logger.create("_getClaimsFromJwt");
      try {
        const r = fe.decode(s);
        return i.debug("JWT decoding successful"), r;
      } catch (r) {
        throw i.error("Error parsing JWT response"), r;
      }
    }, this._jsonService = new Ae(
      void 0,
      this._getClaimsFromJwt,
      this._settings.extraHeaders
    );
  }
  async getClaims(e) {
    const t = this._logger.create("getClaims");
    e || this._logger.throw(new Error("No token passed"));
    const s = await this._metadataService.getUserInfoEndpoint();
    t.debug("got userinfo url", s);
    const i = await this._jsonService.getJson(s, {
      token: e,
      credentials: this._settings.fetchRequestCredentials
    });
    return t.debug("got claims", i), i;
  }
}, Xe = class {
  constructor(e, t) {
    this._settings = e, this._metadataService = t, this._logger = new u("TokenClient"), this._jsonService = new Ae(
      this._settings.revokeTokenAdditionalContentTypes,
      null,
      this._settings.extraHeaders
    );
  }
  /**
   * Exchange code.
   *
   * @see https://www.rfc-editor.org/rfc/rfc6749#section-4.1.3
   */
  async exchangeCode({
    grant_type: e = "authorization_code",
    redirect_uri: t = this._settings.redirect_uri,
    client_id: s = this._settings.client_id,
    client_secret: i = this._settings.client_secret,
    ...r
  }) {
    const n = this._logger.create("exchangeCode");
    s || n.throw(new Error("A client_id is required")), t || n.throw(new Error("A redirect_uri is required")), r.code || n.throw(new Error("A code is required"));
    const c = new URLSearchParams({ grant_type: e, redirect_uri: t });
    for (const [h, g] of Object.entries(r))
      g != null && c.set(h, g);
    let o;
    switch (this._settings.client_authentication) {
      case "client_secret_basic":
        if (!i)
          throw n.throw(new Error("A client_secret is required")), null;
        o = z.generateBasicAuth(s, i);
        break;
      case "client_secret_post":
        c.append("client_id", s), i && c.append("client_secret", i);
        break;
    }
    const l = await this._metadataService.getTokenEndpoint(!1);
    n.debug("got token endpoint");
    const d = await this._jsonService.postForm(l, { body: c, basicAuth: o, initCredentials: this._settings.fetchRequestCredentials });
    return n.debug("got response"), d;
  }
  /**
   * Exchange credentials.
   *
   * @see https://www.rfc-editor.org/rfc/rfc6749#section-4.3.2
   */
  async exchangeCredentials({
    grant_type: e = "password",
    client_id: t = this._settings.client_id,
    client_secret: s = this._settings.client_secret,
    scope: i = this._settings.scope,
    ...r
  }) {
    const n = this._logger.create("exchangeCredentials");
    t || n.throw(new Error("A client_id is required"));
    const c = new URLSearchParams({ grant_type: e, scope: i });
    for (const [h, g] of Object.entries(r))
      g != null && c.set(h, g);
    let o;
    switch (this._settings.client_authentication) {
      case "client_secret_basic":
        if (!s)
          throw n.throw(new Error("A client_secret is required")), null;
        o = z.generateBasicAuth(t, s);
        break;
      case "client_secret_post":
        c.append("client_id", t), s && c.append("client_secret", s);
        break;
    }
    const l = await this._metadataService.getTokenEndpoint(!1);
    n.debug("got token endpoint");
    const d = await this._jsonService.postForm(l, { body: c, basicAuth: o, initCredentials: this._settings.fetchRequestCredentials });
    return n.debug("got response"), d;
  }
  /**
   * Exchange a refresh token.
   *
   * @see https://www.rfc-editor.org/rfc/rfc6749#section-6
   */
  async exchangeRefreshToken({
    grant_type: e = "refresh_token",
    client_id: t = this._settings.client_id,
    client_secret: s = this._settings.client_secret,
    timeoutInSeconds: i,
    ...r
  }) {
    const n = this._logger.create("exchangeRefreshToken");
    t || n.throw(new Error("A client_id is required")), r.refresh_token || n.throw(new Error("A refresh_token is required"));
    const c = new URLSearchParams({ grant_type: e });
    for (const [h, g] of Object.entries(r))
      Array.isArray(g) ? g.forEach((v) => c.append(h, v)) : g != null && c.set(h, g);
    let o;
    switch (this._settings.client_authentication) {
      case "client_secret_basic":
        if (!s)
          throw n.throw(new Error("A client_secret is required")), null;
        o = z.generateBasicAuth(t, s);
        break;
      case "client_secret_post":
        c.append("client_id", t), s && c.append("client_secret", s);
        break;
    }
    const l = await this._metadataService.getTokenEndpoint(!1);
    n.debug("got token endpoint");
    const d = await this._jsonService.postForm(l, { body: c, basicAuth: o, timeoutInSeconds: i, initCredentials: this._settings.fetchRequestCredentials });
    return n.debug("got response"), d;
  }
  /**
   * Revoke an access or refresh token.
   *
   * @see https://datatracker.ietf.org/doc/html/rfc7009#section-2.1
   */
  async revoke(e) {
    var t;
    const s = this._logger.create("revoke");
    e.token || s.throw(new Error("A token is required"));
    const i = await this._metadataService.getRevocationEndpoint(!1);
    s.debug(`got revocation endpoint, revoking ${(t = e.token_type_hint) != null ? t : "default token type"}`);
    const r = new URLSearchParams();
    for (const [n, c] of Object.entries(e))
      c != null && r.set(n, c);
    r.set("client_id", this._settings.client_id), this._settings.client_secret && r.set("client_secret", this._settings.client_secret), await this._jsonService.postForm(i, { body: r }), s.debug("got response");
  }
}, rs = class {
  constructor(e, t, s) {
    this._settings = e, this._metadataService = t, this._claimsService = s, this._logger = new u("ResponseValidator"), this._userInfoService = new is(this._settings, this._metadataService), this._tokenClient = new Xe(this._settings, this._metadataService);
  }
  async validateSigninResponse(e, t) {
    const s = this._logger.create("validateSigninResponse");
    this._processSigninState(e, t), s.debug("state processed"), await this._processCode(e, t), s.debug("code processed"), e.isOpenId && this._validateIdTokenAttributes(e), s.debug("tokens validated"), await this._processClaims(e, t == null ? void 0 : t.skipUserInfo, e.isOpenId), s.debug("claims processed");
  }
  async validateCredentialsResponse(e, t) {
    const s = this._logger.create("validateCredentialsResponse");
    e.isOpenId && e.id_token && this._validateIdTokenAttributes(e), s.debug("tokens validated"), await this._processClaims(e, t, e.isOpenId), s.debug("claims processed");
  }
  async validateRefreshResponse(e, t) {
    var s, i;
    const r = this._logger.create("validateRefreshResponse");
    e.userState = t.data, (s = e.session_state) != null || (e.session_state = t.session_state), (i = e.scope) != null || (e.scope = t.scope), e.isOpenId && e.id_token && (this._validateIdTokenAttributes(e, t.id_token), r.debug("ID Token validated")), e.id_token || (e.id_token = t.id_token, e.profile = t.profile);
    const n = e.isOpenId && !!e.id_token;
    await this._processClaims(e, !1, n), r.debug("claims processed");
  }
  validateSignoutResponse(e, t) {
    const s = this._logger.create("validateSignoutResponse");
    if (t.id !== e.state && s.throw(new Error("State does not match")), s.debug("state validated"), e.userState = t.data, e.error)
      throw s.warn("Response was error", e.error), new W(e);
  }
  _processSigninState(e, t) {
    var s;
    const i = this._logger.create("_processSigninState");
    if (t.id !== e.state && i.throw(new Error("State does not match")), t.client_id || i.throw(new Error("No client_id on state")), t.authority || i.throw(new Error("No authority on state")), this._settings.authority !== t.authority && i.throw(new Error("authority mismatch on settings vs. signin state")), this._settings.client_id && this._settings.client_id !== t.client_id && i.throw(new Error("client_id mismatch on settings vs. signin state")), i.debug("state validated"), e.userState = t.data, e.url_state = t.url_state, (s = e.scope) != null || (e.scope = t.scope), e.error)
      throw i.warn("Response was error", e.error), new W(e);
    t.code_verifier && !e.code && i.throw(new Error("Expected code in response"));
  }
  async _processClaims(e, t = !1, s = !0) {
    const i = this._logger.create("_processClaims");
    if (e.profile = this._claimsService.filterProtocolClaims(e.profile), t || !this._settings.loadUserInfo || !e.access_token) {
      i.debug("not loading user info");
      return;
    }
    i.debug("loading user info");
    const r = await this._userInfoService.getClaims(e.access_token);
    i.debug("user info claims received from user info endpoint"), s && r.sub !== e.profile.sub && i.throw(new Error("subject from UserInfo response does not match subject in ID Token")), e.profile = this._claimsService.mergeClaims(e.profile, this._claimsService.filterProtocolClaims(r)), i.debug("user info claims received, updated profile:", e.profile);
  }
  async _processCode(e, t) {
    const s = this._logger.create("_processCode");
    if (e.code) {
      s.debug("Validating code");
      const i = await this._tokenClient.exchangeCode({
        client_id: t.client_id,
        client_secret: t.client_secret,
        code: e.code,
        redirect_uri: t.redirect_uri,
        code_verifier: t.code_verifier,
        ...t.extraTokenParams
      });
      Object.assign(e, i);
    } else
      s.debug("No code to process");
  }
  _validateIdTokenAttributes(e, t) {
    var s;
    const i = this._logger.create("_validateIdTokenAttributes");
    i.debug("decoding ID Token JWT");
    const r = fe.decode((s = e.id_token) != null ? s : "");
    if (r.sub || i.throw(new Error("ID Token is missing a subject claim")), t) {
      const n = fe.decode(t);
      r.sub !== n.sub && i.throw(new Error("sub in id_token does not match current sub")), r.auth_time && r.auth_time !== n.auth_time && i.throw(new Error("auth_time in id_token does not match original auth_time")), r.azp && r.azp !== n.azp && i.throw(new Error("azp in id_token does not match original azp")), !r.azp && n.azp && i.throw(new Error("azp not in id_token, but present in original id_token"));
    }
    e.profile = r;
  }
}, ne = class Se {
  constructor(t) {
    this.id = t.id || z.generateUUIDv4(), this.data = t.data, t.created && t.created > 0 ? this.created = t.created : this.created = M.getEpochTime(), this.request_type = t.request_type, this.url_state = t.url_state;
  }
  toStorageString() {
    return new u("State").create("toStorageString"), JSON.stringify({
      id: this.id,
      data: this.data,
      created: this.created,
      request_type: this.request_type,
      url_state: this.url_state
    });
  }
  static fromStorageString(t) {
    return u.createStatic("State", "fromStorageString"), Promise.resolve(new Se(JSON.parse(t)));
  }
  static async clearStaleState(t, s) {
    const i = u.createStatic("State", "clearStaleState"), r = M.getEpochTime() - s, n = await t.getAllKeys();
    i.debug("got keys", n);
    for (let c = 0; c < n.length; c++) {
      const o = n[c], l = await t.get(o);
      let d = !1;
      if (l)
        try {
          const h = await Se.fromStorageString(l);
          i.debug("got item from key:", o, h.created), h.created <= r && (d = !0);
        } catch (h) {
          i.error("Error parsing state for key:", o, h), d = !0;
        }
      else
        i.debug("no item in storage for key:", o), d = !0;
      d && (i.debug("removed item for key:", o), t.remove(o));
    }
  }
}, Ye = class be extends ne {
  constructor(t) {
    super(t), this.code_verifier = t.code_verifier, this.code_challenge = t.code_challenge, this.authority = t.authority, this.client_id = t.client_id, this.redirect_uri = t.redirect_uri, this.scope = t.scope, this.client_secret = t.client_secret, this.extraTokenParams = t.extraTokenParams, this.response_mode = t.response_mode, this.skipUserInfo = t.skipUserInfo;
  }
  static async create(t) {
    const s = t.code_verifier === !0 ? z.generateCodeVerifier() : t.code_verifier || void 0, i = s ? await z.generateCodeChallenge(s) : void 0;
    return new be({
      ...t,
      code_verifier: s,
      code_challenge: i
    });
  }
  toStorageString() {
    return new u("SigninState").create("toStorageString"), JSON.stringify({
      id: this.id,
      data: this.data,
      created: this.created,
      request_type: this.request_type,
      url_state: this.url_state,
      code_verifier: this.code_verifier,
      authority: this.authority,
      client_id: this.client_id,
      redirect_uri: this.redirect_uri,
      scope: this.scope,
      client_secret: this.client_secret,
      extraTokenParams: this.extraTokenParams,
      response_mode: this.response_mode,
      skipUserInfo: this.skipUserInfo
    });
  }
  static fromStorageString(t) {
    u.createStatic("SigninState", "fromStorageString");
    const s = JSON.parse(t);
    return be.create(s);
  }
}, Ze = class et {
  constructor(t) {
    this.url = t.url, this.state = t.state;
  }
  static async create({
    // mandatory
    url: t,
    authority: s,
    client_id: i,
    redirect_uri: r,
    response_type: n,
    scope: c,
    // optional
    state_data: o,
    response_mode: l,
    request_type: d,
    client_secret: h,
    nonce: g,
    url_state: v,
    resource: b,
    skipUserInfo: R,
    extraQueryParams: k,
    extraTokenParams: x,
    disablePKCE: E,
    ...H
  }) {
    if (!t)
      throw this._logger.error("create: No url passed"), new Error("url");
    if (!i)
      throw this._logger.error("create: No client_id passed"), new Error("client_id");
    if (!r)
      throw this._logger.error("create: No redirect_uri passed"), new Error("redirect_uri");
    if (!n)
      throw this._logger.error("create: No response_type passed"), new Error("response_type");
    if (!c)
      throw this._logger.error("create: No scope passed"), new Error("scope");
    if (!s)
      throw this._logger.error("create: No authority passed"), new Error("authority");
    const T = await Ye.create({
      data: o,
      request_type: d,
      url_state: v,
      code_verifier: !E,
      client_id: i,
      authority: s,
      redirect_uri: r,
      response_mode: l,
      client_secret: h,
      scope: c,
      extraTokenParams: x,
      skipUserInfo: R
    }), w = new URL(t);
    w.searchParams.append("client_id", i), w.searchParams.append("redirect_uri", r), w.searchParams.append("response_type", n), w.searchParams.append("scope", c), g && w.searchParams.append("nonce", g);
    let U = T.id;
    v && (U = `${U}${we}${v}`), w.searchParams.append("state", U), T.code_challenge && (w.searchParams.append("code_challenge", T.code_challenge), w.searchParams.append("code_challenge_method", "S256")), b && (Array.isArray(b) ? b : [b]).forEach((S) => w.searchParams.append("resource", S));
    for (const [C, S] of Object.entries({ response_mode: l, ...H, ...k }))
      S != null && w.searchParams.append(C, S.toString());
    return new et({
      url: w.href,
      state: T
    });
  }
};
Ze._logger = new u("SigninRequest");
var ns = Ze, os = "openid", he = class {
  constructor(e) {
    if (this.access_token = "", this.token_type = "", this.profile = {}, this.state = e.get("state"), this.session_state = e.get("session_state"), this.state) {
      const t = decodeURIComponent(this.state).split(we);
      this.state = t[0], t.length > 1 && (this.url_state = t.slice(1).join(we));
    }
    this.error = e.get("error"), this.error_description = e.get("error_description"), this.error_uri = e.get("error_uri"), this.code = e.get("code");
  }
  get expires_in() {
    if (this.expires_at !== void 0)
      return this.expires_at - M.getEpochTime();
  }
  set expires_in(e) {
    typeof e == "string" && (e = Number(e)), e !== void 0 && e >= 0 && (this.expires_at = Math.floor(e) + M.getEpochTime());
  }
  get isOpenId() {
    var e;
    return ((e = this.scope) == null ? void 0 : e.split(" ").includes(os)) || !!this.id_token;
  }
}, as = class {
  constructor({
    url: e,
    state_data: t,
    id_token_hint: s,
    post_logout_redirect_uri: i,
    extraQueryParams: r,
    request_type: n,
    client_id: c
  }) {
    if (this._logger = new u("SignoutRequest"), !e)
      throw this._logger.error("ctor: No url passed"), new Error("url");
    const o = new URL(e);
    s && o.searchParams.append("id_token_hint", s), c && o.searchParams.append("client_id", c), i && (o.searchParams.append("post_logout_redirect_uri", i), t && (this.state = new ne({ data: t, request_type: n }), o.searchParams.append("state", this.state.id)));
    for (const [l, d] of Object.entries({ ...r }))
      d != null && o.searchParams.append(l, d.toString());
    this.url = o.href;
  }
}, cs = class {
  constructor(e) {
    this.state = e.get("state"), this.error = e.get("error"), this.error_description = e.get("error_description"), this.error_uri = e.get("error_uri");
  }
}, ls = [
  "nbf",
  "jti",
  "auth_time",
  "nonce",
  "acr",
  "amr",
  "azp",
  "at_hash"
  // https://openid.net/specs/openid-connect-core-1_0.html#CodeIDToken
], ds = ["sub", "iss", "aud", "exp", "iat"], hs = class {
  constructor(e) {
    this._settings = e, this._logger = new u("ClaimsService");
  }
  filterProtocolClaims(e) {
    const t = { ...e };
    if (this._settings.filterProtocolClaims) {
      let s;
      Array.isArray(this._settings.filterProtocolClaims) ? s = this._settings.filterProtocolClaims : s = ls;
      for (const i of s)
        ds.includes(i) || delete t[i];
    }
    return t;
  }
  mergeClaims(e, t) {
    const s = { ...e };
    for (const [i, r] of Object.entries(t))
      if (s[i] !== r)
        if (Array.isArray(s[i]) || Array.isArray(r))
          if (this._settings.mergeClaimsStrategy.array == "replace")
            s[i] = r;
          else {
            const n = Array.isArray(s[i]) ? s[i] : [s[i]];
            for (const c of Array.isArray(r) ? r : [r])
              n.includes(c) || n.push(c);
            s[i] = n;
          }
        else
          typeof s[i] == "object" && typeof r == "object" ? s[i] = this.mergeClaims(s[i], r) : s[i] = r;
    return s;
  }
}, gs = class {
  constructor(e, t) {
    this._logger = new u("OidcClient"), this.settings = e instanceof ve ? e : new ve(e), this.metadataService = t ?? new Yt(this.settings), this._claimsService = new hs(this.settings), this._validator = new rs(this.settings, this.metadataService, this._claimsService), this._tokenClient = new Xe(this.settings, this.metadataService);
  }
  async createSigninRequest({
    state: e,
    request: t,
    request_uri: s,
    request_type: i,
    id_token_hint: r,
    login_hint: n,
    skipUserInfo: c,
    nonce: o,
    url_state: l,
    response_type: d = this.settings.response_type,
    scope: h = this.settings.scope,
    redirect_uri: g = this.settings.redirect_uri,
    prompt: v = this.settings.prompt,
    display: b = this.settings.display,
    max_age: R = this.settings.max_age,
    ui_locales: k = this.settings.ui_locales,
    acr_values: x = this.settings.acr_values,
    resource: E = this.settings.resource,
    response_mode: H = this.settings.response_mode,
    extraQueryParams: T = this.settings.extraQueryParams,
    extraTokenParams: w = this.settings.extraTokenParams
  }) {
    const U = this._logger.create("createSigninRequest");
    if (d !== "code")
      throw new Error("Only the Authorization Code flow (with PKCE) is supported");
    const C = await this.metadataService.getAuthorizationEndpoint();
    U.debug("Received authorization endpoint", C);
    const S = await ns.create({
      url: C,
      authority: this.settings.authority,
      client_id: this.settings.client_id,
      redirect_uri: g,
      response_type: d,
      scope: h,
      state_data: e,
      url_state: l,
      prompt: v,
      display: b,
      max_age: R,
      ui_locales: k,
      id_token_hint: r,
      login_hint: n,
      acr_values: x,
      resource: E,
      request: t,
      request_uri: s,
      extraQueryParams: T,
      extraTokenParams: w,
      request_type: i,
      response_mode: H,
      client_secret: this.settings.client_secret,
      skipUserInfo: c,
      nonce: o,
      disablePKCE: this.settings.disablePKCE
    });
    await this.clearStaleState();
    const L = S.state;
    return await this.settings.stateStore.set(L.id, L.toStorageString()), S;
  }
  async readSigninResponseState(e, t = !1) {
    const s = this._logger.create("readSigninResponseState"), i = new he(me.readParams(e, this.settings.response_mode));
    if (!i.state)
      throw s.throw(new Error("No state in response")), null;
    const r = await this.settings.stateStore[t ? "remove" : "get"](i.state);
    if (!r)
      throw s.throw(new Error("No matching state found in storage")), null;
    return { state: await Ye.fromStorageString(r), response: i };
  }
  async processSigninResponse(e) {
    const t = this._logger.create("processSigninResponse"), { state: s, response: i } = await this.readSigninResponseState(e, !0);
    return t.debug("received state from storage; validating response"), await this._validator.validateSigninResponse(i, s), i;
  }
  async processResourceOwnerPasswordCredentials({
    username: e,
    password: t,
    skipUserInfo: s = !1,
    extraTokenParams: i = {}
  }) {
    const r = await this._tokenClient.exchangeCredentials({ username: e, password: t, ...i }), n = new he(new URLSearchParams());
    return Object.assign(n, r), await this._validator.validateCredentialsResponse(n, s), n;
  }
  async useRefreshToken({
    state: e,
    redirect_uri: t,
    resource: s,
    timeoutInSeconds: i,
    extraTokenParams: r
  }) {
    var n;
    const c = this._logger.create("useRefreshToken");
    let o;
    if (this.settings.refreshTokenAllowedScope === void 0)
      o = e.scope;
    else {
      const h = this.settings.refreshTokenAllowedScope.split(" ");
      o = (((n = e.scope) == null ? void 0 : n.split(" ")) || []).filter((v) => h.includes(v)).join(" ");
    }
    const l = await this._tokenClient.exchangeRefreshToken({
      refresh_token: e.refresh_token,
      // provide the (possible filtered) scope list
      scope: o,
      redirect_uri: t,
      resource: s,
      timeoutInSeconds: i,
      ...r
    }), d = new he(new URLSearchParams());
    return Object.assign(d, l), c.debug("validating response", d), await this._validator.validateRefreshResponse(d, {
      ...e,
      // override the scope in the state handed over to the validator
      // so it can set the granted scope to the requested scope in case none is included in the response
      scope: o
    }), d;
  }
  async createSignoutRequest({
    state: e,
    id_token_hint: t,
    client_id: s,
    request_type: i,
    post_logout_redirect_uri: r = this.settings.post_logout_redirect_uri,
    extraQueryParams: n = this.settings.extraQueryParams
  } = {}) {
    const c = this._logger.create("createSignoutRequest"), o = await this.metadataService.getEndSessionEndpoint();
    if (!o)
      throw c.throw(new Error("No end session endpoint")), null;
    c.debug("Received end session endpoint", o), !s && r && !t && (s = this.settings.client_id);
    const l = new as({
      url: o,
      id_token_hint: t,
      client_id: s,
      post_logout_redirect_uri: r,
      state_data: e,
      extraQueryParams: n,
      request_type: i
    });
    await this.clearStaleState();
    const d = l.state;
    return d && (c.debug("Signout request has state to persist"), await this.settings.stateStore.set(d.id, d.toStorageString())), l;
  }
  async readSignoutResponseState(e, t = !1) {
    const s = this._logger.create("readSignoutResponseState"), i = new cs(me.readParams(e, this.settings.response_mode));
    if (!i.state) {
      if (s.debug("No state in response"), i.error)
        throw s.warn("Response was error:", i.error), new W(i);
      return { state: void 0, response: i };
    }
    const r = await this.settings.stateStore[t ? "remove" : "get"](i.state);
    if (!r)
      throw s.throw(new Error("No matching state found in storage")), null;
    return { state: await ne.fromStorageString(r), response: i };
  }
  async processSignoutResponse(e) {
    const t = this._logger.create("processSignoutResponse"), { state: s, response: i } = await this.readSignoutResponseState(e, !0);
    return s ? (t.debug("Received state from storage; validating response"), this._validator.validateSignoutResponse(i, s)) : t.debug("No state from storage; skipping response validation"), i;
  }
  clearStaleState() {
    return this._logger.create("clearStaleState"), ne.clearStaleState(this.settings.stateStore, this.settings.staleStateAgeInSeconds);
  }
  async revokeToken(e, t) {
    return this._logger.create("revokeToken"), await this._tokenClient.revoke({
      token: e,
      token_type_hint: t
    });
  }
}, us = class {
  constructor(e) {
    this._userManager = e, this._logger = new u("SessionMonitor"), this._start = async (t) => {
      const s = t.session_state;
      if (!s)
        return;
      const i = this._logger.create("_start");
      if (t.profile ? (this._sub = t.profile.sub, i.debug("session_state", s, ", sub", this._sub)) : (this._sub = void 0, i.debug("session_state", s, ", anonymous user")), this._checkSessionIFrame) {
        this._checkSessionIFrame.start(s);
        return;
      }
      try {
        const r = await this._userManager.metadataService.getCheckSessionIframe();
        if (r) {
          i.debug("initializing check session iframe");
          const n = this._userManager.settings.client_id, c = this._userManager.settings.checkSessionIntervalInSeconds, o = this._userManager.settings.stopCheckSessionOnError, l = new Xt(this._callback, n, r, c, o);
          await l.load(), this._checkSessionIFrame = l, l.start(s);
        } else
          i.warn("no check session iframe found in the metadata");
      } catch (r) {
        i.error("Error from getCheckSessionIframe:", r instanceof Error ? r.message : r);
      }
    }, this._stop = () => {
      const t = this._logger.create("_stop");
      if (this._sub = void 0, this._checkSessionIFrame && this._checkSessionIFrame.stop(), this._userManager.settings.monitorAnonymousSession) {
        const s = setInterval(async () => {
          clearInterval(s);
          try {
            const i = await this._userManager.querySessionStatus();
            if (i) {
              const r = {
                session_state: i.session_state,
                profile: i.sub ? {
                  sub: i.sub
                } : null
              };
              this._start(r);
            }
          } catch (i) {
            t.error("error from querySessionStatus", i instanceof Error ? i.message : i);
          }
        }, 1e3);
      }
    }, this._callback = async () => {
      const t = this._logger.create("_callback");
      try {
        const s = await this._userManager.querySessionStatus();
        let i = !0;
        s && this._checkSessionIFrame ? s.sub === this._sub ? (i = !1, this._checkSessionIFrame.start(s.session_state), t.debug("same sub still logged in at OP, session state has changed, restarting check session iframe; session_state", s.session_state), await this._userManager.events._raiseUserSessionChanged()) : t.debug("different subject signed into OP", s.sub) : t.debug("subject no longer signed into OP"), i ? this._sub ? await this._userManager.events._raiseUserSignedOut() : await this._userManager.events._raiseUserSignedIn() : t.debug("no change in session detected, no event to raise");
      } catch (s) {
        this._sub && (t.debug("Error calling queryCurrentSigninSession; raising signed out event", s), await this._userManager.events._raiseUserSignedOut());
      }
    }, e || this._logger.throw(new Error("No user manager passed")), this._userManager.events.addUserLoaded(this._start), this._userManager.events.addUserUnloaded(this._stop), this._init().catch((t) => {
      this._logger.error(t);
    });
  }
  async _init() {
    this._logger.create("_init");
    const e = await this._userManager.getUser();
    if (e)
      this._start(e);
    else if (this._userManager.settings.monitorAnonymousSession) {
      const t = await this._userManager.querySessionStatus();
      if (t) {
        const s = {
          session_state: t.session_state,
          profile: t.sub ? {
            sub: t.sub
          } : null
        };
        this._start(s);
      }
    }
  }
}, ge = class tt {
  constructor(t) {
    var s;
    this.id_token = t.id_token, this.session_state = (s = t.session_state) != null ? s : null, this.access_token = t.access_token, this.refresh_token = t.refresh_token, this.token_type = t.token_type, this.scope = t.scope, this.profile = t.profile, this.expires_at = t.expires_at, this.state = t.userState, this.url_state = t.url_state;
  }
  /** Computed number of seconds the access token has remaining. */
  get expires_in() {
    if (this.expires_at !== void 0)
      return this.expires_at - M.getEpochTime();
  }
  set expires_in(t) {
    t !== void 0 && (this.expires_at = Math.floor(t) + M.getEpochTime());
  }
  /** Computed value indicating if the access token is expired. */
  get expired() {
    const t = this.expires_in;
    if (t !== void 0)
      return t <= 0;
  }
  /** Array representing the parsed values from the `scope`. */
  get scopes() {
    var t, s;
    return (s = (t = this.scope) == null ? void 0 : t.split(" ")) != null ? s : [];
  }
  toStorageString() {
    return new u("User").create("toStorageString"), JSON.stringify({
      id_token: this.id_token,
      session_state: this.session_state,
      access_token: this.access_token,
      refresh_token: this.refresh_token,
      token_type: this.token_type,
      scope: this.scope,
      profile: this.profile,
      expires_at: this.expires_at
    });
  }
  static fromStorageString(t) {
    return u.createStatic("User", "fromStorageString"), new tt(JSON.parse(t));
  }
}, $e = "oidc-client", st = class {
  constructor() {
    this._abort = new F("Window navigation aborted"), this._disposeHandlers = /* @__PURE__ */ new Set(), this._window = null;
  }
  async navigate(e) {
    const t = this._logger.create("navigate");
    if (!this._window)
      throw new Error("Attempted to navigate on a disposed window");
    t.debug("setting URL in window"), this._window.location.replace(e.url);
    const { url: s, keepOpen: i } = await new Promise((r, n) => {
      const c = (o) => {
        var l;
        const d = o.data, h = (l = e.scriptOrigin) != null ? l : window.location.origin;
        if (!(o.origin !== h || (d == null ? void 0 : d.source) !== $e)) {
          try {
            const g = me.readParams(d.url, e.response_mode).get("state");
            if (g || t.warn("no state found in response url"), o.source !== this._window && g !== e.state)
              return;
          } catch {
            this._dispose(), n(new Error("Invalid response from window"));
          }
          r(d);
        }
      };
      window.addEventListener("message", c, !1), this._disposeHandlers.add(() => window.removeEventListener("message", c, !1)), this._disposeHandlers.add(this._abort.addHandler((o) => {
        this._dispose(), n(o);
      }));
    });
    return t.debug("got response from window"), this._dispose(), i || this.close(), { url: s };
  }
  _dispose() {
    this._logger.create("_dispose");
    for (const e of this._disposeHandlers)
      e();
    this._disposeHandlers.clear();
  }
  static _notifyParent(e, t, s = !1, i = window.location.origin) {
    e.postMessage({
      source: $e,
      url: t,
      keepOpen: s
    }, i);
  }
}, it = {
  location: !1,
  toolbar: !1,
  height: 640,
  closePopupWindowAfterInSeconds: -1
}, rt = "_blank", _s = 60, ps = 2, nt = 10, fs = class extends ve {
  constructor(e) {
    const {
      popup_redirect_uri: t = e.redirect_uri,
      popup_post_logout_redirect_uri: s = e.post_logout_redirect_uri,
      popupWindowFeatures: i = it,
      popupWindowTarget: r = rt,
      redirectMethod: n = "assign",
      redirectTarget: c = "self",
      iframeNotifyParentOrigin: o = e.iframeNotifyParentOrigin,
      iframeScriptOrigin: l = e.iframeScriptOrigin,
      silent_redirect_uri: d = e.redirect_uri,
      silentRequestTimeoutInSeconds: h = nt,
      automaticSilentRenew: g = !0,
      validateSubOnSilentRenew: v = !0,
      includeIdTokenInSilentRenew: b = !1,
      monitorSession: R = !1,
      monitorAnonymousSession: k = !1,
      checkSessionIntervalInSeconds: x = ps,
      query_status_response_type: E = "code",
      stopCheckSessionOnError: H = !0,
      revokeTokenTypes: T = ["access_token", "refresh_token"],
      revokeTokensOnSignout: w = !1,
      includeIdTokenInSilentSignout: U = !1,
      accessTokenExpiringNotificationTimeInSeconds: C = _s,
      userStore: S
    } = e;
    if (super(e), this.popup_redirect_uri = t, this.popup_post_logout_redirect_uri = s, this.popupWindowFeatures = i, this.popupWindowTarget = r, this.redirectMethod = n, this.redirectTarget = c, this.iframeNotifyParentOrigin = o, this.iframeScriptOrigin = l, this.silent_redirect_uri = d, this.silentRequestTimeoutInSeconds = h, this.automaticSilentRenew = g, this.validateSubOnSilentRenew = v, this.includeIdTokenInSilentRenew = b, this.monitorSession = R, this.monitorAnonymousSession = k, this.checkSessionIntervalInSeconds = x, this.stopCheckSessionOnError = H, this.query_status_response_type = E, this.revokeTokenTypes = T, this.revokeTokensOnSignout = w, this.includeIdTokenInSilentSignout = U, this.accessTokenExpiringNotificationTimeInSeconds = C, S)
      this.userStore = S;
    else {
      const L = typeof window < "u" ? window.sessionStorage : new Ge();
      this.userStore = new Qe({ store: L });
    }
  }
}, We = class ot extends st {
  constructor({
    silentRequestTimeoutInSeconds: t = nt
  }) {
    super(), this._logger = new u("IFrameWindow"), this._timeoutInSeconds = t, this._frame = ot.createHiddenIframe(), this._window = this._frame.contentWindow;
  }
  static createHiddenIframe() {
    const t = window.document.createElement("iframe");
    return t.style.visibility = "hidden", t.style.position = "fixed", t.style.left = "-1000px", t.style.top = "0", t.width = "0", t.height = "0", window.document.body.appendChild(t), t;
  }
  async navigate(t) {
    this._logger.debug("navigate: Using timeout of:", this._timeoutInSeconds);
    const s = setTimeout(() => void this._abort.raise(new Ue("IFrame timed out without a response")), this._timeoutInSeconds * 1e3);
    return this._disposeHandlers.add(() => clearTimeout(s)), await super.navigate(t);
  }
  close() {
    var t;
    this._frame && (this._frame.parentNode && (this._frame.addEventListener("load", (s) => {
      var i;
      const r = s.target;
      (i = r.parentNode) == null || i.removeChild(r), this._abort.raise(new Error("IFrame removed from DOM"));
    }, !0), (t = this._frame.contentWindow) == null || t.location.replace("about:blank")), this._frame = null), this._window = null;
  }
  static notifyParent(t, s) {
    return super._notifyParent(window.parent, t, !1, s);
  }
}, ms = class {
  constructor(e) {
    this._settings = e, this._logger = new u("IFrameNavigator");
  }
  async prepare({
    silentRequestTimeoutInSeconds: e = this._settings.silentRequestTimeoutInSeconds
  }) {
    return new We({ silentRequestTimeoutInSeconds: e });
  }
  async callback(e) {
    this._logger.create("callback"), We.notifyParent(e, this._settings.iframeNotifyParentOrigin);
  }
}, ws = 500, vs = 1e3, Ke = class extends st {
  constructor({
    popupWindowTarget: e = rt,
    popupWindowFeatures: t = {}
  }) {
    super(), this._logger = new u("PopupWindow");
    const s = De.center({ ...it, ...t });
    this._window = window.open(void 0, e, De.serialize(s)), t.closePopupWindowAfterInSeconds && t.closePopupWindowAfterInSeconds > 0 && setTimeout(() => {
      if (!this._window || typeof this._window.closed != "boolean" || this._window.closed) {
        this._abort.raise(new Error("Popup blocked by user"));
        return;
      }
      this.close();
    }, t.closePopupWindowAfterInSeconds * vs);
  }
  async navigate(e) {
    var t;
    (t = this._window) == null || t.focus();
    const s = setInterval(() => {
      (!this._window || this._window.closed) && this._abort.raise(new Error("Popup closed by user"));
    }, ws);
    return this._disposeHandlers.add(() => clearInterval(s)), await super.navigate(e);
  }
  close() {
    this._window && (this._window.closed || (this._window.close(), this._abort.raise(new Error("Popup closed")))), this._window = null;
  }
  static notifyOpener(e, t) {
    if (!window.opener)
      throw new Error("No window.opener. Can't complete notification.");
    return super._notifyParent(window.opener, e, t);
  }
}, Ss = class {
  constructor(e) {
    this._settings = e, this._logger = new u("PopupNavigator");
  }
  async prepare({
    popupWindowFeatures: e = this._settings.popupWindowFeatures,
    popupWindowTarget: t = this._settings.popupWindowTarget
  }) {
    return new Ke({ popupWindowFeatures: e, popupWindowTarget: t });
  }
  async callback(e, { keepOpen: t = !1 }) {
    this._logger.create("callback"), Ke.notifyOpener(e, t);
  }
}, bs = class {
  constructor(e) {
    this._settings = e, this._logger = new u("RedirectNavigator");
  }
  async prepare({
    redirectMethod: e = this._settings.redirectMethod,
    redirectTarget: t = this._settings.redirectTarget
  }) {
    var s;
    this._logger.create("prepare");
    let i = window.self;
    t === "top" && (i = (s = window.top) != null ? s : window.self);
    const r = i.location[e].bind(i.location);
    let n;
    return {
      navigate: async (c) => {
        this._logger.create("navigate");
        const o = new Promise((l, d) => {
          n = d;
        });
        return r(c.url), await o;
      },
      close: () => {
        this._logger.create("close"), n == null || n(new Error("Redirect aborted")), i.stop();
      }
    };
  }
  async callback() {
  }
}, ys = class extends Qt {
  constructor(e) {
    super({ expiringNotificationTimeInSeconds: e.accessTokenExpiringNotificationTimeInSeconds }), this._logger = new u("UserManagerEvents"), this._userLoaded = new F("User loaded"), this._userUnloaded = new F("User unloaded"), this._silentRenewError = new F("Silent renew error"), this._userSignedIn = new F("User signed in"), this._userSignedOut = new F("User signed out"), this._userSessionChanged = new F("User session changed");
  }
  async load(e, t = !0) {
    super.load(e), t && await this._userLoaded.raise(e);
  }
  async unload() {
    super.unload(), await this._userUnloaded.raise();
  }
  /**
   * Add callback: Raised when a user session has been established (or re-established).
   */
  addUserLoaded(e) {
    return this._userLoaded.addHandler(e);
  }
  /**
   * Remove callback: Raised when a user session has been established (or re-established).
   */
  removeUserLoaded(e) {
    return this._userLoaded.removeHandler(e);
  }
  /**
   * Add callback: Raised when a user session has been terminated.
   */
  addUserUnloaded(e) {
    return this._userUnloaded.addHandler(e);
  }
  /**
   * Remove callback: Raised when a user session has been terminated.
   */
  removeUserUnloaded(e) {
    return this._userUnloaded.removeHandler(e);
  }
  /**
   * Add callback: Raised when the automatic silent renew has failed.
   */
  addSilentRenewError(e) {
    return this._silentRenewError.addHandler(e);
  }
  /**
   * Remove callback: Raised when the automatic silent renew has failed.
   */
  removeSilentRenewError(e) {
    return this._silentRenewError.removeHandler(e);
  }
  /**
   * @internal
   */
  async _raiseSilentRenewError(e) {
    await this._silentRenewError.raise(e);
  }
  /**
   * Add callback: Raised when the user is signed in (when `monitorSession` is set).
   * @see {@link UserManagerSettings.monitorSession}
   */
  addUserSignedIn(e) {
    return this._userSignedIn.addHandler(e);
  }
  /**
   * Remove callback: Raised when the user is signed in (when `monitorSession` is set).
   */
  removeUserSignedIn(e) {
    this._userSignedIn.removeHandler(e);
  }
  /**
   * @internal
   */
  async _raiseUserSignedIn() {
    await this._userSignedIn.raise();
  }
  /**
   * Add callback: Raised when the user's sign-in status at the OP has changed (when `monitorSession` is set).
   * @see {@link UserManagerSettings.monitorSession}
   */
  addUserSignedOut(e) {
    return this._userSignedOut.addHandler(e);
  }
  /**
   * Remove callback: Raised when the user's sign-in status at the OP has changed (when `monitorSession` is set).
   */
  removeUserSignedOut(e) {
    this._userSignedOut.removeHandler(e);
  }
  /**
   * @internal
   */
  async _raiseUserSignedOut() {
    await this._userSignedOut.raise();
  }
  /**
   * Add callback: Raised when the user session changed (when `monitorSession` is set).
   * @see {@link UserManagerSettings.monitorSession}
   */
  addUserSessionChanged(e) {
    return this._userSessionChanged.addHandler(e);
  }
  /**
   * Remove callback: Raised when the user session changed (when `monitorSession` is set).
   */
  removeUserSessionChanged(e) {
    this._userSessionChanged.removeHandler(e);
  }
  /**
   * @internal
   */
  async _raiseUserSessionChanged() {
    await this._userSessionChanged.raise();
  }
}, ks = class {
  constructor(e) {
    this._userManager = e, this._logger = new u("SilentRenewService"), this._isStarted = !1, this._retryTimer = new M("Retry Silent Renew"), this._tokenExpiring = async () => {
      const t = this._logger.create("_tokenExpiring");
      try {
        await this._userManager.signinSilent(), t.debug("silent token renewal successful");
      } catch (s) {
        if (s instanceof Ue) {
          t.warn("ErrorTimeout from signinSilent:", s, "retry in 5s"), this._retryTimer.init(5);
          return;
        }
        t.error("Error from signinSilent:", s), await this._userManager.events._raiseSilentRenewError(s);
      }
    };
  }
  async start() {
    const e = this._logger.create("start");
    if (!this._isStarted) {
      this._isStarted = !0, this._userManager.events.addAccessTokenExpiring(this._tokenExpiring), this._retryTimer.addHandler(this._tokenExpiring);
      try {
        await this._userManager.getUser();
      } catch (t) {
        e.error("getUser error", t);
      }
    }
  }
  stop() {
    this._isStarted && (this._retryTimer.cancel(), this._retryTimer.removeHandler(this._tokenExpiring), this._userManager.events.removeAccessTokenExpiring(this._tokenExpiring), this._isStarted = !1);
  }
}, Ts = class {
  constructor(e) {
    this.refresh_token = e.refresh_token, this.id_token = e.id_token, this.session_state = e.session_state, this.scope = e.scope, this.profile = e.profile, this.data = e.state;
  }
}, Is = class {
  constructor(e, t, s, i) {
    this._logger = new u("UserManager"), this.settings = new fs(e), this._client = new gs(e), this._redirectNavigator = t ?? new bs(this.settings), this._popupNavigator = s ?? new Ss(this.settings), this._iframeNavigator = i ?? new ms(this.settings), this._events = new ys(this.settings), this._silentRenewService = new ks(this), this.settings.automaticSilentRenew && this.startSilentRenew(), this._sessionMonitor = null, this.settings.monitorSession && (this._sessionMonitor = new us(this));
  }
  /**
   * Get object used to register for events raised by the `UserManager`.
   */
  get events() {
    return this._events;
  }
  /**
   * Get object used to access the metadata configuration of the identity provider.
   */
  get metadataService() {
    return this._client.metadataService;
  }
  /**
   * Load the `User` object for the currently authenticated user.
   *
   * @returns A promise
   */
  async getUser() {
    const e = this._logger.create("getUser"), t = await this._loadUser();
    return t ? (e.info("user loaded"), await this._events.load(t, !1), t) : (e.info("user not found in storage"), null);
  }
  /**
   * Remove from any storage the currently authenticated user.
   *
   * @returns A promise
   */
  async removeUser() {
    const e = this._logger.create("removeUser");
    await this.storeUser(null), e.info("user removed from storage"), await this._events.unload();
  }
  /**
   * Trigger a redirect of the current window to the authorization endpoint.
   *
   * @returns A promise
   *
   * @throws `Error` In cases of wrong authentication.
   */
  async signinRedirect(e = {}) {
    this._logger.create("signinRedirect");
    const {
      redirectMethod: t,
      ...s
    } = e, i = await this._redirectNavigator.prepare({ redirectMethod: t });
    await this._signinStart({
      request_type: "si:r",
      ...s
    }, i);
  }
  /**
   * Process the response (callback) from the authorization endpoint.
   * It is recommend to use {@link UserManager.signinCallback} instead.
   *
   * @returns A promise containing the authenticated `User`.
   *
   * @see {@link UserManager.signinCallback}
   */
  async signinRedirectCallback(e = window.location.href) {
    const t = this._logger.create("signinRedirectCallback"), s = await this._signinEnd(e);
    return s.profile && s.profile.sub ? t.info("success, signed in subject", s.profile.sub) : t.info("no subject"), s;
  }
  /**
   * Trigger the signin with user/password.
   *
   * @returns A promise containing the authenticated `User`.
   * @throws {@link ErrorResponse} In cases of wrong authentication.
   */
  async signinResourceOwnerCredentials({
    username: e,
    password: t,
    skipUserInfo: s = !1
  }) {
    const i = this._logger.create("signinResourceOwnerCredential"), r = await this._client.processResourceOwnerPasswordCredentials({ username: e, password: t, skipUserInfo: s, extraTokenParams: this.settings.extraTokenParams });
    i.debug("got signin response");
    const n = await this._buildUser(r);
    return n.profile && n.profile.sub ? i.info("success, signed in subject", n.profile.sub) : i.info("no subject"), n;
  }
  /**
   * Trigger a request (via a popup window) to the authorization endpoint.
   *
   * @returns A promise containing the authenticated `User`.
   * @throws `Error` In cases of wrong authentication.
   */
  async signinPopup(e = {}) {
    const t = this._logger.create("signinPopup"), {
      popupWindowFeatures: s,
      popupWindowTarget: i,
      ...r
    } = e, n = this.settings.popup_redirect_uri;
    n || t.throw(new Error("No popup_redirect_uri configured"));
    const c = await this._popupNavigator.prepare({ popupWindowFeatures: s, popupWindowTarget: i }), o = await this._signin({
      request_type: "si:p",
      redirect_uri: n,
      display: "popup",
      ...r
    }, c);
    return o && (o.profile && o.profile.sub ? t.info("success, signed in subject", o.profile.sub) : t.info("no subject")), o;
  }
  /**
   * Notify the opening window of response (callback) from the authorization endpoint.
   * It is recommend to use {@link UserManager.signinCallback} instead.
   *
   * @returns A promise
   *
   * @see {@link UserManager.signinCallback}
   */
  async signinPopupCallback(e = window.location.href, t = !1) {
    const s = this._logger.create("signinPopupCallback");
    await this._popupNavigator.callback(e, { keepOpen: t }), s.info("success");
  }
  /**
   * Trigger a silent request (via refresh token or an iframe) to the authorization endpoint.
   *
   * @returns A promise that contains the authenticated `User`.
   */
  async signinSilent(e = {}) {
    var t;
    const s = this._logger.create("signinSilent"), {
      silentRequestTimeoutInSeconds: i,
      ...r
    } = e;
    let n = await this._loadUser();
    if (n != null && n.refresh_token) {
      s.debug("using refresh token");
      const d = new Ts(n);
      return await this._useRefreshToken({
        state: d,
        redirect_uri: r.redirect_uri,
        resource: r.resource,
        extraTokenParams: r.extraTokenParams,
        timeoutInSeconds: i
      });
    }
    const c = this.settings.silent_redirect_uri;
    c || s.throw(new Error("No silent_redirect_uri configured"));
    let o;
    n && this.settings.validateSubOnSilentRenew && (s.debug("subject prior to silent renew:", n.profile.sub), o = n.profile.sub);
    const l = await this._iframeNavigator.prepare({ silentRequestTimeoutInSeconds: i });
    return n = await this._signin({
      request_type: "si:s",
      redirect_uri: c,
      prompt: "none",
      id_token_hint: this.settings.includeIdTokenInSilentRenew ? n == null ? void 0 : n.id_token : void 0,
      ...r
    }, l, o), n && ((t = n.profile) != null && t.sub ? s.info("success, signed in subject", n.profile.sub) : s.info("no subject")), n;
  }
  async _useRefreshToken(e) {
    const t = await this._client.useRefreshToken({
      ...e,
      timeoutInSeconds: this.settings.silentRequestTimeoutInSeconds
    }), s = new ge({ ...e.state, ...t });
    return await this.storeUser(s), await this._events.load(s), s;
  }
  /**
   *
   * Notify the parent window of response (callback) from the authorization endpoint.
   * It is recommend to use {@link UserManager.signinCallback} instead.
   *
   * @returns A promise
   *
   * @see {@link UserManager.signinCallback}
   */
  async signinSilentCallback(e = window.location.href) {
    const t = this._logger.create("signinSilentCallback");
    await this._iframeNavigator.callback(e), t.info("success");
  }
  /**
   * Process any response (callback) from the authorization endpoint, by dispatching the request_type
   * and executing one of the following functions:
   * - {@link UserManager.signinRedirectCallback}
   * - {@link UserManager.signinPopupCallback}
   * - {@link UserManager.signinSilentCallback}
   *
   * @throws `Error` If request_type is unknown or signout can not processed.
   */
  async signinCallback(e = window.location.href) {
    const { state: t } = await this._client.readSigninResponseState(e);
    switch (t.request_type) {
      case "si:r":
        return await this.signinRedirectCallback(e);
      case "si:p":
        return await this.signinPopupCallback(e);
      case "si:s":
        return await this.signinSilentCallback(e);
      default:
        throw new Error("invalid response_type in state");
    }
  }
  /**
   * Process any response (callback) from the end session endpoint, by dispatching the request_type
   * and executing one of the following functions:
   * - {@link UserManager.signoutRedirectCallback}
   * - {@link UserManager.signoutPopupCallback}
   * - {@link UserManager.signoutSilentCallback}
   *
   * @throws `Error` If request_type is unknown or signout can not processed.
   */
  async signoutCallback(e = window.location.href, t = !1) {
    const { state: s } = await this._client.readSignoutResponseState(e);
    if (s)
      switch (s.request_type) {
        case "so:r":
          await this.signoutRedirectCallback(e);
          break;
        case "so:p":
          await this.signoutPopupCallback(e, t);
          break;
        case "so:s":
          await this.signoutSilentCallback(e);
          break;
        default:
          throw new Error("invalid response_type in state");
      }
  }
  /**
   * Query OP for user's current signin status.
   *
   * @returns A promise object with session_state and subject identifier.
   */
  async querySessionStatus(e = {}) {
    const t = this._logger.create("querySessionStatus"), {
      silentRequestTimeoutInSeconds: s,
      ...i
    } = e, r = this.settings.silent_redirect_uri;
    r || t.throw(new Error("No silent_redirect_uri configured"));
    const n = await this._loadUser(), c = await this._iframeNavigator.prepare({ silentRequestTimeoutInSeconds: s }), o = await this._signinStart({
      request_type: "si:s",
      // this acts like a signin silent
      redirect_uri: r,
      prompt: "none",
      id_token_hint: this.settings.includeIdTokenInSilentRenew ? n == null ? void 0 : n.id_token : void 0,
      response_type: this.settings.query_status_response_type,
      scope: "openid",
      skipUserInfo: !0,
      ...i
    }, c);
    try {
      const l = await this._client.processSigninResponse(o.url);
      return t.debug("got signin response"), l.session_state && l.profile.sub ? (t.info("success for subject", l.profile.sub), {
        session_state: l.session_state,
        sub: l.profile.sub
      }) : (t.info("success, user not authenticated"), null);
    } catch (l) {
      if (this.settings.monitorAnonymousSession && l instanceof W)
        switch (l.error) {
          case "login_required":
          case "consent_required":
          case "interaction_required":
          case "account_selection_required":
            return t.info("success for anonymous user"), {
              // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
              session_state: l.session_state
            };
        }
      throw l;
    }
  }
  async _signin(e, t, s) {
    const i = await this._signinStart(e, t);
    return await this._signinEnd(i.url, s);
  }
  async _signinStart(e, t) {
    const s = this._logger.create("_signinStart");
    try {
      const i = await this._client.createSigninRequest(e);
      return s.debug("got signin request"), await t.navigate({
        url: i.url,
        state: i.state.id,
        response_mode: i.state.response_mode,
        scriptOrigin: this.settings.iframeScriptOrigin
      });
    } catch (i) {
      throw s.debug("error after preparing navigator, closing navigator window"), t.close(), i;
    }
  }
  async _signinEnd(e, t) {
    const s = this._logger.create("_signinEnd"), i = await this._client.processSigninResponse(e);
    return s.debug("got signin response"), await this._buildUser(i, t);
  }
  async _buildUser(e, t) {
    const s = this._logger.create("_buildUser"), i = new ge(e);
    if (t) {
      if (t !== i.profile.sub)
        throw s.debug("current user does not match user returned from signin. sub from signin:", i.profile.sub), new W({ ...e, error: "login_required" });
      s.debug("current user matches user returned from signin");
    }
    return await this.storeUser(i), s.debug("user stored"), await this._events.load(i), i;
  }
  /**
   * Trigger a redirect of the current window to the end session endpoint.
   *
   * @returns A promise
   */
  async signoutRedirect(e = {}) {
    const t = this._logger.create("signoutRedirect"), {
      redirectMethod: s,
      ...i
    } = e, r = await this._redirectNavigator.prepare({ redirectMethod: s });
    await this._signoutStart({
      request_type: "so:r",
      post_logout_redirect_uri: this.settings.post_logout_redirect_uri,
      ...i
    }, r), t.info("success");
  }
  /**
   * Process response (callback) from the end session endpoint.
   * It is recommend to use {@link UserManager.signoutCallback} instead.
   *
   * @returns A promise containing signout response
   *
   * @see {@link UserManager.signoutCallback}
   */
  async signoutRedirectCallback(e = window.location.href) {
    const t = this._logger.create("signoutRedirectCallback"), s = await this._signoutEnd(e);
    return t.info("success"), s;
  }
  /**
   * Trigger a redirect of a popup window window to the end session endpoint.
   *
   * @returns A promise
   */
  async signoutPopup(e = {}) {
    const t = this._logger.create("signoutPopup"), {
      popupWindowFeatures: s,
      popupWindowTarget: i,
      ...r
    } = e, n = this.settings.popup_post_logout_redirect_uri, c = await this._popupNavigator.prepare({ popupWindowFeatures: s, popupWindowTarget: i });
    await this._signout({
      request_type: "so:p",
      post_logout_redirect_uri: n,
      // we're putting a dummy entry in here because we
      // need a unique id from the state for notification
      // to the parent window, which is necessary if we
      // plan to return back to the client after signout
      // and so we can close the popup after signout
      state: n == null ? void 0 : {},
      ...r
    }, c), t.info("success");
  }
  /**
   * Process response (callback) from the end session endpoint from a popup window.
   * It is recommend to use {@link UserManager.signoutCallback} instead.
   *
   * @returns A promise
   *
   * @see {@link UserManager.signoutCallback}
   */
  async signoutPopupCallback(e = window.location.href, t = !1) {
    const s = this._logger.create("signoutPopupCallback");
    await this._popupNavigator.callback(e, { keepOpen: t }), s.info("success");
  }
  async _signout(e, t) {
    const s = await this._signoutStart(e, t);
    return await this._signoutEnd(s.url);
  }
  async _signoutStart(e = {}, t) {
    var s;
    const i = this._logger.create("_signoutStart");
    try {
      const r = await this._loadUser();
      i.debug("loaded current user from storage"), this.settings.revokeTokensOnSignout && await this._revokeInternal(r);
      const n = e.id_token_hint || r && r.id_token;
      n && (i.debug("setting id_token_hint in signout request"), e.id_token_hint = n), await this.removeUser(), i.debug("user removed, creating signout request");
      const c = await this._client.createSignoutRequest(e);
      return i.debug("got signout request"), await t.navigate({
        url: c.url,
        state: (s = c.state) == null ? void 0 : s.id,
        scriptOrigin: this.settings.iframeScriptOrigin
      });
    } catch (r) {
      throw i.debug("error after preparing navigator, closing navigator window"), t.close(), r;
    }
  }
  async _signoutEnd(e) {
    const t = this._logger.create("_signoutEnd"), s = await this._client.processSignoutResponse(e);
    return t.debug("got signout response"), s;
  }
  /**
   * Trigger a silent request (via an iframe) to the end session endpoint.
   *
   * @returns A promise
   */
  async signoutSilent(e = {}) {
    var t;
    const s = this._logger.create("signoutSilent"), {
      silentRequestTimeoutInSeconds: i,
      ...r
    } = e, n = this.settings.includeIdTokenInSilentSignout ? (t = await this._loadUser()) == null ? void 0 : t.id_token : void 0, c = this.settings.popup_post_logout_redirect_uri, o = await this._iframeNavigator.prepare({ silentRequestTimeoutInSeconds: i });
    await this._signout({
      request_type: "so:s",
      post_logout_redirect_uri: c,
      id_token_hint: n,
      ...r
    }, o), s.info("success");
  }
  /**
   * Notify the parent window of response (callback) from the end session endpoint.
   * It is recommend to use {@link UserManager.signoutCallback} instead.
   *
   * @returns A promise
   *
   * @see {@link UserManager.signoutCallback}
   */
  async signoutSilentCallback(e = window.location.href) {
    const t = this._logger.create("signoutSilentCallback");
    await this._iframeNavigator.callback(e), t.info("success");
  }
  async revokeTokens(e) {
    const t = await this._loadUser();
    await this._revokeInternal(t, e);
  }
  async _revokeInternal(e, t = this.settings.revokeTokenTypes) {
    const s = this._logger.create("_revokeInternal");
    if (!e)
      return;
    const i = t.filter((r) => typeof e[r] == "string");
    if (!i.length) {
      s.debug("no need to revoke due to no token(s)");
      return;
    }
    for (const r of i)
      await this._client.revokeToken(
        e[r],
        // eslint-disable-line @typescript-eslint/no-non-null-assertion
        r
      ), s.info(`${r} revoked successfully`), r !== "access_token" && (e[r] = null);
    await this.storeUser(e), s.debug("user stored"), await this._events.load(e);
  }
  /**
   * Enables silent renew for the `UserManager`.
   */
  startSilentRenew() {
    this._logger.create("startSilentRenew"), this._silentRenewService.start();
  }
  /**
   * Disables silent renew for the `UserManager`.
   */
  stopSilentRenew() {
    this._silentRenewService.stop();
  }
  get _userStoreKey() {
    return `user:${this.settings.authority}:${this.settings.client_id}`;
  }
  async _loadUser() {
    const e = this._logger.create("_loadUser"), t = await this.settings.userStore.get(this._userStoreKey);
    return t ? (e.debug("user storageString loaded"), ge.fromStorageString(t)) : (e.debug("no user storageString"), null);
  }
  async storeUser(e) {
    const t = this._logger.create("storeUser");
    if (e) {
      t.debug("storing user");
      const s = e.toStorageString();
      await this.settings.userStore.set(this._userStoreKey, s);
    } else
      this._logger.debug("removing user"), await this.settings.userStore.remove(this._userStoreKey);
  }
  /**
   * Removes stale state entries in storage for incomplete authorize requests.
   */
  async clearStaleState() {
    await this._client.clearStaleState();
  }
};
const Es = ["url", "clientId", "redirectUri", "scope", "logoutUrl"], Cs = "openid profile email";
function Rs(e, t) {
  const s = {};
  return e.forEach((i) => {
    t[i] !== void 0 && (s[i] = t[i]);
  }), s;
}
let _, K;
const xs = (e) => (K = Rs(Es, e), new Is({
  authority: K.url,
  client_id: K.clientId,
  redirect_uri: K.redirectUri,
  response_type: "code",
  scope: K.scope || Cs,
  filterProtocolClaims: !0,
  includeIdTokenInSilentRenew: !0,
  includeIdTokenInSilentSignout: !0,
  loadUserInfo: !0
})), Us = async () => {
  try {
    console.debug("[Auth] Logging in using OIDC");
    const e = new URL(window.location.href), t = await (_ == null ? void 0 : _.getUser());
    e.searchParams.get("state") || t ? await (_ == null ? void 0 : _.signinRedirectCallback()) : await (_ == null ? void 0 : _.signinRedirect().then(() => {
      _ == null || _.startSilentRenew(), _ == null || _.signinRedirectCallback();
    }).catch((s) => {
      console.log(s);
    }));
  } catch (e) {
    console.error("[Auth] Error logging in using OIDC: ", e);
  }
}, As = async () => _ == null ? void 0 : _.removeUser().then(() => _ == null ? void 0 : _.signoutRedirect({
  post_logout_redirect_uri: K.logoutUrl || window.location.href
})), Ps = async () => await (_ == null ? void 0 : _.getUser()) != null, Os = async () => {
  const e = await (_ == null ? void 0 : _.getUser());
  return Promise.resolve(e == null ? void 0 : e.id_token);
}, Ns = async () => {
  const e = await (_ == null ? void 0 : _.getUser());
  return Promise.resolve(e == null ? void 0 : e.profile.preferred_username);
};
let J, Q;
const qs = async (e, t) => {
  try {
    console.debug("[Auth] Setting Username and Password for BasicAuth"), J = e, Q = t;
  } catch (s) {
    console.error("[Auth] Error logging in using BasicAuth: ", s);
  }
}, js = async () => {
  console.debug("[Auth] Logout for BasicAuth"), J = void 0, Q = void 0, window.location.reload();
}, Hs = async () => J !== void 0 && Q !== void 0, Ls = async () => Promise.resolve(J), Ms = () => {
  if (J !== void 0 && Q != null)
    return {
      username: J,
      password: Q
    };
}, at = () => {
  const e = ut(Kt);
  return e.type === "oidc" ? (_ === void 0 && (console.debug("[Auth] Creating OIDC UserManager with options: ", e.options), _ = xs(e.options)), {
    isOidcAuthEnabled: () => !0,
    isBasicAuthEnabled: () => !1,
    isAuthenticated: Ps,
    getToken: Os,
    getUsernameAndPassword: () => {
    },
    getUsername: Ns,
    login: Us,
    logout: As
  }) : e.type === "basic" ? {
    isOidcAuthEnabled: () => !1,
    isBasicAuthEnabled: () => !0,
    isAuthenticated: Hs,
    getToken: () => Promise.resolve(void 0),
    getUsernameAndPassword: Ms,
    getUsername: Ls,
    login: qs,
    logout: js
  } : {
    isOidcAuthEnabled: () => !1,
    isBasicAuthEnabled: () => !1,
    isAuthenticated: () => Promise.resolve(!1),
    getToken: () => Promise.resolve(void 0),
    getUsername: () => Promise.resolve(void 0),
    getUsernameAndPassword: () => {
    },
    login: () => Promise.resolve(),
    logout: () => Promise.resolve()
  };
}, ye = (e) => {
  const [t, s] = I(null), i = e.format || "locale";
  return Te(() => {
    let r;
    if (e.date && typeof e.date == "string" ? r = de.fromISO(e.date) : e.date && typeof e.date == "object" && (r = de.fromJSDate(e.date)), r) {
      const n = {
        locale: e.locale
      };
      s(i === "fromNow" ? r.toRelative() : i === "locale" ? r.toLocaleString(de.DATETIME_FULL, n) : r.toFormat(i, n));
    } else
      s(null);
  }, [e.date]), /* @__PURE__ */ a("span", { children: t || "" });
}, Ys = (e) => /* @__PURE__ */ a(ye, { date: e.date, format: "fromNow" }), A = ({ condition: e, children: t }) => (typeof e == "boolean" ? e : e()) ? /* @__PURE__ */ a(j.Fragment, { children: t }) : /* @__PURE__ */ a(j.Fragment, {}), Zs = ({ collection: e, emptyState: t, emptyStateTitle: s, emptyStateMessage: i, children: r }) => {
  const n = () => !e || e.length === 0, c = t || /* @__PURE__ */ f(te, { variant: _t.xs, children: [
    /* @__PURE__ */ a(se, { titleText: s || "None found", headingLevel: "h4" }),
    /* @__PURE__ */ a(ue, { children: i || "No items found." })
  ] });
  return n() ? /* @__PURE__ */ a(j.Fragment, { children: c }) : /* @__PURE__ */ a(j.Fragment, { children: r });
}, oe = ({ isLoading: e, loadingComponent: t, children: s }) => {
  const i = () => typeof e == "boolean" ? e : e(), r = t || /* @__PURE__ */ a(X, {});
  return i() ? /* @__PURE__ */ a(j.Fragment, { children: r }) : /* @__PURE__ */ a(j.Fragment, { children: s });
}, ei = ({ toolbar: e, alwaysShowToolbar: t, emptyState: s, filteredEmptyState: i, isLoading: r, isError: n, loadingComponent: c, errorComponent: o, isEmpty: l, isFiltered: d, children: h }) => {
  const g = t || !l || d || n;
  return o || (o = /* @__PURE__ */ a("div", { style: { padding: "15px", backgroundColor: "white" }, children: /* @__PURE__ */ a(pt, { isInline: !0, variant: "danger", title: "Error: Something went wrong!", children: /* @__PURE__ */ a("p", { children: "Something went wrong with the action you attempted, but we're not sure what it was. Try reloading the page and hopef for a better result, or contact your admin to report the error." }) }) })), /* @__PURE__ */ f(j.Fragment, { children: [
    /* @__PURE__ */ a(A, { condition: g, children: e }),
    /* @__PURE__ */ f(oe, { isLoading: r, loadingComponent: c, children: [
      /* @__PURE__ */ a(A, { condition: !l && !n, children: h }),
      /* @__PURE__ */ a(A, { condition: l && d && !n, children: i }),
      /* @__PURE__ */ a(A, { condition: l && !d && !n, children: s }),
      /* @__PURE__ */ a(A, { condition: n, children: o })
    ] })
  ] });
}, ti = (e) => {
  const [t, s] = I(!1), i = (l, d) => {
    s(!1);
    const h = d;
    h !== void 0 && h >= 0 ? e.onSelect(e.items[h]) : e.onSelect(void 0);
  }, r = () => {
    s(!t);
  }, n = (l) => {
    let d;
    return e.itemToTestId !== void 0 && (d = e.itemToTestId(l)), d;
  }, c = e.popperProps || {
    appendTo: e.menuAppendTo
  };
  let o = /* @__PURE__ */ a(Nt, { title: e.label });
  return e.isKebab || (o = /* @__PURE__ */ a(j.Fragment, { children: e.label })), /* @__PURE__ */ a(
    ft,
    {
      isOpen: t,
      onSelect: i,
      onOpenChange: (l) => s(l),
      toggle: (l) => /* @__PURE__ */ a(
        ce,
        {
          "data-testid": e.testId,
          ref: l,
          onClick: r,
          isExpanded: t,
          variant: e.isKebab ? "plain" : "default",
          children: o
        }
      ),
      ouiaId: "ObjectDropdown",
      popperProps: c,
      shouldFocusToggleOnSelect: !0,
      children: /* @__PURE__ */ a(mt, { children: e.items.map((l, d) => e.itemIsVisible !== void 0 && !e.itemIsVisible(l) ? /* @__PURE__ */ a(ae, {}) : e.itemIsDivider && e.itemIsDivider(l) ? /* @__PURE__ */ a(Je, { component: "li" }, `divider-${d}`) : /* @__PURE__ */ a(
        wt,
        {
          value: d,
          isDisabled: e.itemIsDisabled === void 0 ? !1 : e.itemIsDisabled(l),
          component: (h) => /* @__PURE__ */ a("button", { ...h, "data-testid": n(l) }),
          children: e.itemToString(l)
        },
        `action-${d}`
      )) })
    }
  );
}, si = (e) => {
  var l;
  const [t, s] = I(!1), i = (d, h) => {
    s(!1), e.onSelect(e.items[h]);
  }, r = () => {
    s(!t);
  }, n = (d) => {
    let h;
    return e.itemToTestId !== void 0 && (h = e.itemToTestId(d)), h;
  }, c = (d) => /* @__PURE__ */ a(
    ce,
    {
      ref: d,
      className: e.toggleClassname || "menu-toggle",
      onClick: r,
      "data-testid": e.testId,
      isExpanded: t,
      children: e.value ? e.itemToString(e.value) : e.noSelectionLabel
    }
  ), o = {
    appendTo: e.appendTo === "document" ? () => document.body : "inline"
  };
  return /* @__PURE__ */ a(
    Ee,
    {
      toggle: c,
      id: e.toggleId,
      onSelect: i,
      onOpenChange: s,
      isOpen: t,
      popperProps: o,
      children: (l = e.items) == null ? void 0 : l.map((d, h) => e.itemIsDivider && e.itemIsDivider(d) ? /* @__PURE__ */ a(Je, {}, h) : /* @__PURE__ */ a(
        Ce,
        {
          isSelected: d === e.value,
          component: (g) => /* @__PURE__ */ a("button", { ...g, "data-testid": n(d) }),
          value: h,
          children: e.itemToString(d)
        },
        h
      ))
    }
  );
}, ii = ({ expanded: e, onClick: t }) => e ? /* @__PURE__ */ a(qt, { onClick: t, style: { cursor: "pointer" } }) : /* @__PURE__ */ a(jt, { onClick: t, style: { cursor: "pointer" } }), ct = {
  padding: "5px",
  minHeight: "128px",
  borderRight: 0,
  borderLeft: 0,
  borderBottom: "1px solid #666",
  backgroundColor: "rgb(240, 240, 240)"
}, Fs = {
  ...ct,
  color: "red",
  overflow: "auto"
}, ri = (e) => {
  const [t, s] = I(""), [i, r] = I(""), [n, c] = I(!1), [o, l] = I(), d = (k, x) => {
    s(x);
  }, h = () => t != null && t.trim().length > 0, g = () => o != null && o.trim().length > 0, v = () => {
    c(!0), e.onUrlFetch(t).then((k) => {
      l(void 0), r(k), c(!1), e.onChange(k, t);
    }).catch((k) => {
      l(k.message), c(!1);
    });
  }, b = () => {
    s(""), r(""), e.onChange(void 0, void 0);
  }, R = /* @__PURE__ */ f("div", { className: "url-upload-loading", style: ct, children: [
    /* @__PURE__ */ a(X, { size: "md", className: "spinner", style: { marginRight: "5px" } }),
    /* @__PURE__ */ a("span", { className: "spinner-message", children: "Loading URL content" })
  ] });
  return /* @__PURE__ */ f("div", { className: "url-upload", "data-testid": e.testId, children: [
    /* @__PURE__ */ f("div", { className: "url-upload-flex", style: { display: "flex" }, children: [
      /* @__PURE__ */ a("div", { className: "url-upload-url", style: { flexGrow: 1 }, children: /* @__PURE__ */ a(
        _e,
        {
          "data-testid": `${e.testId}-input`,
          value: t,
          type: "text",
          placeholder: e.urlPlaceholder,
          id: e.id,
          onChange: d,
          "aria-label": "url input"
        }
      ) }),
      /* @__PURE__ */ a("div", { className: "url-fetch-button", children: /* @__PURE__ */ a(pe, { "data-testid": `${e.testId}-fetch`, variant: "control", isDisabled: !h(), onClick: v, children: "Fetch" }) }),
      /* @__PURE__ */ a("div", { className: "url-clear-button", children: /* @__PURE__ */ a(pe, { "data-testid": `${e.testId}-clear`, variant: "control", isDisabled: !h(), onClick: b, children: "Clear" }) })
    ] }),
    /* @__PURE__ */ a("div", { className: "url-upload-preview", children: /* @__PURE__ */ f(oe, { isLoading: n, loadingComponent: R, children: [
      /* @__PURE__ */ a(A, { condition: g, children: /* @__PURE__ */ f("div", { className: "url-upload-error", style: Fs, children: [
        /* @__PURE__ */ a("div", { children: "Error getting content from URL." }),
        /* @__PURE__ */ a("div", { children: o })
      ] }) }),
      /* @__PURE__ */ a(A, { condition: !g(), children: /* @__PURE__ */ a(
        vt,
        {
          "data-testid": `${e.testId}-preview`,
          "aria-label": "url-content",
          value: i,
          readOnly: !0,
          style: { minHeight: "128px" }
        }
      ) })
    ] }) })
  ] });
}, Ds = (e) => {
  const [t, s] = I({
    username: "",
    password: ""
  }), i = () => {
    e.onLogin(t);
  }, r = (c, o) => {
    s({
      ...t,
      username: o
    });
  }, n = (c, o) => {
    s({
      ...t,
      password: o
    });
  };
  return /* @__PURE__ */ a(
    Re,
    {
      title: "Login",
      variant: "small",
      isOpen: !0,
      header: /* @__PURE__ */ a("a", { href: "#" }),
      showClose: !1,
      className: "please-wait pf-m-redhat-font",
      "aria-label": "please-wait-modal",
      style: { marginTop: "-15px" },
      actions: [
        /* @__PURE__ */ a(pe, { variant: "primary", "data-testid": "modal-btn-login", onClick: i, isDisabled: (t == null ? void 0 : t.username) === "" || (t == null ? void 0 : t.password) === "", children: "Login" }, "login")
      ],
      children: /* @__PURE__ */ f(St, { children: [
        /* @__PURE__ */ a(
          je,
          {
            label: "Username",
            fieldId: "form-username",
            children: /* @__PURE__ */ a(
              _e,
              {
                isRequired: !0,
                type: "text",
                id: "form-username",
                "data-testid": "basic-auth-login-modal-username",
                name: "form-username",
                value: t == null ? void 0 : t.username,
                placeholder: "Username",
                onChange: r
              }
            )
          }
        ),
        /* @__PURE__ */ a(
          je,
          {
            label: "Password",
            fieldId: "form-password",
            children: /* @__PURE__ */ a(
              _e,
              {
                isRequired: !0,
                type: "text",
                id: "form-password",
                "data-testid": "basic-auth-login-modal-password",
                name: "form-password",
                value: t == null ? void 0 : t.password,
                placeholder: "Password",
                onChange: n
              }
            )
          }
        )
      ] })
    }
  );
}, ni = (e) => {
  const [t, s] = I(
    0
    /* AUTHENTICATING */
  ), i = at(), r = (n) => {
    console.info("[ApplicationAuth] Using username and password."), i.login(n.username, n.password), s(
      1
      /* AUTHENTICATED */
    );
  };
  return Te(() => {
    i.isOidcAuthEnabled() ? i.login("", "").then(() => {
      console.info("[ApplicationAuth] Authentication successful."), s(
        1
        /* AUTHENTICATED */
      );
    }).catch((n) => {
      console.error("[ApplicationAuth] Authentication failed: ", n), s(
        2
        /* AUTHENTICATION_FAILED */
      );
    }) : i.isBasicAuthEnabled() || s(
      1
      /* AUTHENTICATED */
    );
  }, []), /* @__PURE__ */ f(ae, { children: [
    /* @__PURE__ */ a(A, { condition: t === 0 && i.isOidcAuthEnabled(), children: /* @__PURE__ */ f(te, { children: [
      /* @__PURE__ */ a(se, { titleText: "Loading", headingLevel: "h4" }),
      /* @__PURE__ */ a(ue, { children: /* @__PURE__ */ a(X, { size: "xl", "aria-label": "Loading spinner" }) })
    ] }) }),
    /* @__PURE__ */ a(A, { condition: t === 0 && i.isBasicAuthEnabled(), children: /* @__PURE__ */ a(Ds, { onLogin: r }) }),
    /* @__PURE__ */ a(A, { condition: t === 2, children: /* @__PURE__ */ f(te, { children: [
      /* @__PURE__ */ a(se, { titleText: "Empty state", headingLevel: "h4", icon: /* @__PURE__ */ a(Be, { icon: Ht }) }),
      /* @__PURE__ */ a(ue, { children: "Authentication failed." })
    ] }) }),
    /* @__PURE__ */ a(A, { condition: t === 1, children: e.children })
  ] });
}, oi = (e) => {
  const t = at();
  return (() => {
    let i = !0;
    return e.enabled !== void 0 && (i = i && (t.isOidcAuthEnabled() === e.enabled || t.isBasicAuthEnabled() === e.enabled)), i;
  })() ? /* @__PURE__ */ a(j.Fragment, { children: e.children }) : /* @__PURE__ */ a(j.Fragment, {});
}, ai = (e) => {
  const [t, s] = I(), [i, r] = I();
  return Te(() => {
    e.isOpen && (typeof e.frontendInfo == "function" ? e.frontendInfo().then(s) : s(e.frontendInfo), typeof e.backendInfo == "function" ? e.backendInfo().then(r) : r(e.backendInfo));
  }, [e.isOpen]), /* @__PURE__ */ a(
    bt,
    {
      className: "app-about-modal",
      isOpen: e.isOpen,
      onClose: e.onClose,
      trademark: "© 2024 Red Hat",
      brandImageSrc: e.brandImageSrc,
      brandImageAlt: e.brandImageAlt,
      "aria-label": e.brandImageAlt,
      children: /* @__PURE__ */ f(yt, { className: "app-about-modal-content", style: { marginTop: "-25px" }, children: [
        /* @__PURE__ */ a(He, { component: Le.h2, children: "Web console info" }),
        /* @__PURE__ */ a(oe, { isLoading: t === void 0, children: /* @__PURE__ */ f(Me, { component: "dl", children: [
          /* @__PURE__ */ a(y, { component: "dt", children: "Project" }),
          /* @__PURE__ */ a(y, { component: "dd", children: /* @__PURE__ */ a("a", { href: t == null ? void 0 : t.url, target: "_blank", children: t == null ? void 0 : t.name }) }),
          /* @__PURE__ */ a(y, { component: "dt", children: "Version" }),
          /* @__PURE__ */ a(y, { component: "dd", children: t == null ? void 0 : t.version }),
          /* @__PURE__ */ a(y, { component: "dt", children: "Built on" }),
          /* @__PURE__ */ a(y, { component: "dd", children: /* @__PURE__ */ a(ye, { date: t == null ? void 0 : t.builtOn, format: "locale" }) }),
          /* @__PURE__ */ a(y, { component: "dt", children: "Digest" }),
          /* @__PURE__ */ a(y, { component: "dd", children: t == null ? void 0 : t.digest })
        ] }) }),
        /* @__PURE__ */ a(He, { style: { marginTop: "40px" }, component: Le.h2, children: e.backendLabel }),
        /* @__PURE__ */ a(oe, { isLoading: i === void 0, children: /* @__PURE__ */ f(Me, { component: "dl", children: [
          /* @__PURE__ */ a(y, { component: "dt", children: "Name" }),
          /* @__PURE__ */ a(y, { component: "dd", children: (i == null ? void 0 : i.name) || "" }),
          /* @__PURE__ */ a(y, { component: "dt", children: "Description" }),
          /* @__PURE__ */ a(y, { component: "dd", children: (i == null ? void 0 : i.description) || "" }),
          /* @__PURE__ */ a(y, { component: "dt", children: "Version" }),
          /* @__PURE__ */ a(y, { component: "dd", children: (i == null ? void 0 : i.version) || "" }),
          /* @__PURE__ */ a(y, { component: "dt", children: "Built on" }),
          /* @__PURE__ */ a(y, { component: "dd", children: /* @__PURE__ */ a(ye, { date: i == null ? void 0 : i.builtOn, format: "locale" }) })
        ] }) })
      ] })
    }
  );
}, ci = (e) => /* @__PURE__ */ f(
  Re,
  {
    title: "Please Wait",
    variant: "small",
    isOpen: e.isOpen,
    header: /* @__PURE__ */ a("a", { href: "#" }),
    showClose: !1,
    className: "please-wait pf-m-redhat-font",
    "aria-label": "please-wait-modal",
    style: { marginTop: "-15px" },
    children: [
      /* @__PURE__ */ a(X, { size: "md", className: "spinner" }),
      /* @__PURE__ */ a("span", { className: "message", style: { fontSize: "15px", color: "#333", marginLeft: "10px" }, children: e.message })
    ]
  }
), li = (e) => /* @__PURE__ */ a(
  Re,
  {
    title: e.title,
    variant: "small",
    isOpen: e.isOpen,
    showClose: e.isCloseable,
    onClose: e.onClose,
    className: "progress pf-m-redhat-font",
    "aria-label": "progress-modal",
    children: /* @__PURE__ */ a(kt, { title: e.message, value: e.progress })
  }
);
function di() {
  return /* @__PURE__ */ a(te, { children: /* @__PURE__ */ a(
    se,
    {
      titleText: "Loading",
      headingLevel: "h4",
      icon: /* @__PURE__ */ a(Be, { icon: X })
    }
  ) });
}
function hi({
  itemCount: e,
  page: t,
  perPage: s,
  isCompact: i = !1,
  onChange: r,
  variant: n = It.top
}) {
  return /* @__PURE__ */ a(
    Tt,
    {
      itemCount: e,
      page: t,
      perPage: s,
      onSetPage: (c, o) => r(o, s),
      onPerPageSelect: (c, o) => r(1, o),
      variant: n,
      isCompact: i
    }
  );
}
function $s({ columns: e, rows: t, getTd: s = () => xe }) {
  const i = new Array(e).fill(0).map((n, c) => {
    const o = s(c);
    return /* @__PURE__ */ a(o, { children: /* @__PURE__ */ a(
      Et,
      {
        screenreaderText: c === 0 ? "Loading data" : void 0
      }
    ) }, `cell_${c}`);
  }), r = new Array(t).fill(0).map((n, c) => /* @__PURE__ */ a(ie, { children: i }, `row_${c}`));
  return /* @__PURE__ */ a(ae, { children: r });
}
const gi = ({
  ariaLabel: e,
  minimumColumnWidth: t = 250,
  columns: s,
  data: i,
  renderHeader: r,
  renderCell: n,
  renderActions: c,
  isColumnSortable: o,
  isRowDeleted: l,
  isRowSelected: d,
  expectedLength: h = 3,
  onRowClick: g,
  setActionCellOuiaId: v,
  setRowOuiaId: b,
  tableOuiaId: R,
  children: k,
  variant: x
}) => {
  const [E, H] = I(1e3);
  let T;
  const w = ({ width: p }) => {
    T && cancelAnimationFrame(T), p && (T = requestAnimationFrame(() => {
      H(p);
    }));
  }, { ref: U } = Wt({ onResize: w }), C = E >= 576, S = Ne(
    (p) => C && p !== 0 && p !== s.length - 1,
    [s, C]
  ), L = qe(() => s.map((p, m) => {
    const P = ee(
      ({ children: D, ...$ }, le) => /* @__PURE__ */ a(
        lt,
        {
          position: m,
          tableWidth: E,
          columnWidth: t,
          canHide: S(m),
          sort: o ? o(p) : void 0,
          ...$,
          ref: le,
          children: D
        }
      )
    );
    return P.displayName = "ResponsiveThCurried", r({
      Th: P,
      key: `header_${p}`,
      column: p,
      colIndex: m
    });
  }), [
    S,
    s,
    o,
    t,
    r,
    E
  ]), B = Ne(
    (p) => {
      const m = ee(
        ({ children: P, ...D }, $) => /* @__PURE__ */ a(
          ke,
          {
            position: p,
            tableWidth: E,
            columnWidth: t,
            canHide: S(p),
            ...D,
            ref: $,
            children: P
          }
        )
      );
      return m.displayName = "ResponsiveTdCurried", m;
    },
    [S, t, E]
  ), Y = qe(
    () => s.map((p, m) => B(m)),
    [s, B]
  );
  return /* @__PURE__ */ f(
    Mt,
    {
      "aria-label": e,
      gridBreakPoint: "",
      ref: U,
      className: C ? "" : "pf-m-grid",
      ouiaId: R,
      variant: x,
      children: [
        /* @__PURE__ */ a(Ft, { children: /* @__PURE__ */ a(ie, { children: L }) }),
        /* @__PURE__ */ f(Dt, { children: [
          i === void 0 && /* @__PURE__ */ a(
            $s,
            {
              columns: s.length,
              rows: h,
              getTd: B
            }
          ),
          i == null ? void 0 : i.map((p, m) => {
            const P = l !== void 0 && l({ row: p, rowIndex: m }), D = d !== void 0 && d({ row: p, rowIndex: m }), $ = !P && g ? () => g({ row: p, rowIndex: m }) : void 0, le = s.map((Pe, Oe) => n({
              Td: Y[Oe],
              key: `row_${m}_cell_${Pe}`,
              column: Pe,
              colIndex: Oe,
              rowIndex: m,
              row: p
            })), ht = !P && c && /* @__PURE__ */ a(
              ke,
              {
                position: s.length,
                tableWidth: E,
                columnWidth: t,
                canHide: !1,
                isActionCell: !0,
                "data-testid": v ? v({ row: p, rowIndex: m }) : `actions-for-row-${m}`,
                children: c({ rowIndex: m, row: p, ActionsColumn: $t })
              }
            );
            return /* @__PURE__ */ f(
              dt,
              {
                isDeleted: P,
                isSelected: D,
                onClick: $,
                rowOuiaId: b == null ? void 0 : b({ row: p, rowIndex: m }),
                children: [
                  le,
                  ht
                ]
              },
              `row_${m}`
            );
          }),
          (i == null ? void 0 : i.length) === 0 && /* @__PURE__ */ a(ie, { children: /* @__PURE__ */ a(xe, { colSpan: s.length, children: k }) })
        ] })
      ]
    }
  );
}, lt = Ie(
  ee((e, t) => {
    const {
      tableWidth: s,
      columnWidth: i,
      position: r,
      canHide: n,
      className: c = "",
      children: o,
      ...l
    } = e, d = n && s < i * (r + 1) ? "pf-m-hidden" : "pf-m-visible";
    return /* @__PURE__ */ a(
      Lt,
      {
        ref: t,
        className: `${d} ${c}`,
        ...l,
        children: o
      }
    );
  })
);
lt.displayName = "ResponsiveTh";
const ke = Ie(
  ee((e, t) => {
    const {
      tableWidth: s,
      columnWidth: i,
      position: r,
      canHide: n,
      className: c = "",
      children: o,
      ...l
    } = e, d = n && s < i * (r + 1) ? "pf-m-hidden" : "pf-m-visible";
    return /* @__PURE__ */ a(
      xe,
      {
        ref: t,
        className: `${d} ${c}`,
        ...l,
        children: o
      }
    );
  })
);
ke.displayName = "ResponsiveTd";
const dt = Ie(
  ({ isDeleted: e, isSelected: t, onClick: s, children: i, rowOuiaId: r }) => /* @__PURE__ */ a(
    ie,
    {
      onRowClick: (n) => {
        (n == null ? void 0 : n.target) instanceof HTMLElement && (["a", "button"].includes(n.target.tagName.toLowerCase()) || s && s());
      },
      ouiaId: r,
      isRowSelected: t,
      className: e ? "mas--ResponsiveTable__Tr--deleted" : void 0,
      "data-testid": [t && "row-selected", e && "row-deleted"].filter((n) => !!n).join(" "),
      role: "row",
      children: i
    }
  )
);
dt.displayName = "DeletableRow";
const Ws = ({ label: e, onSearch: t }) => {
  const s = (i, r, n) => {
    t(r);
  };
  return /* @__PURE__ */ a(
    Ct,
    {
      placeholder: `Filter by ${e}`,
      onSearch: s
    }
  );
};
function ze({
  options: e,
  value: t,
  onChange: s,
  ouiaId: i
}) {
  const [r, n] = I(!1);
  return /* @__PURE__ */ a(
    Ee,
    {
      toggle: (o) => /* @__PURE__ */ a(
        ce,
        {
          ref: o,
          onClick: () => n((l) => !l),
          isExpanded: r,
          variant: "plain",
          children: /* @__PURE__ */ a(Ve, {})
        }
      ),
      "aria-label": "table:select_filter",
      selected: t,
      isOpen: r,
      onSelect: (o, l) => {
        s(l), n(!1);
      },
      ouiaId: i,
      children: /* @__PURE__ */ a(Rt, { children: e.map((o, l) => /* @__PURE__ */ a(Ce, { value: o, children: o }, l)) })
    }
  );
}
function Ks({
  label: e,
  chips: t,
  options: s,
  onToggle: i
}) {
  const [r, n] = I(!1);
  return /* @__PURE__ */ a(
    Ee,
    {
      "aria-label": e,
      onSelect: (c, o) => {
        i(o);
      },
      selected: t,
      isOpen: r,
      toggle: (c) => /* @__PURE__ */ a(
        ce,
        {
          ref: c,
          onClick: () => n((o) => !o),
          isExpanded: r,
          style: {
            width: "200px"
          },
          children: `Filter by ${e}`
        }
      ),
      children: Object.entries(s).map(([c, o]) => /* @__PURE__ */ a(Ce, { value: c, hasCheckbox: !0, children: o }, c))
    }
  );
}
function ui({ filters: e, breakpoint: t = "md" }) {
  const s = Object.keys(e), [i, r] = I(s[0]), n = (c, o) => {
    switch (o.type) {
      case "search":
        return /* @__PURE__ */ a(
          Ws,
          {
            onSearch: o.onSearch,
            label: c,
            validate: o.validate,
            errorMessage: o.errorMessage
          }
        );
      case "checkbox":
        return /* @__PURE__ */ a(
          Ks,
          {
            chips: o.chips,
            options: o.options,
            onToggle: o.onToggle,
            label: c
          }
        );
    }
  };
  return /* @__PURE__ */ f(ae, { children: [
    /* @__PURE__ */ a(
      xt,
      {
        variant: "search-filter",
        visibility: { default: "hidden", [t]: "visible" },
        "data-testid": "large-viewport-toolbar",
        children: /* @__PURE__ */ f(Ut, { children: [
          s.length > 1 && /* @__PURE__ */ a(
            ze,
            {
              options: s,
              value: i,
              onChange: r,
              ouiaId: "chip-filter-selector-large-viewport"
            }
          ),
          n(i, e[i])
        ] })
      }
    ),
    /* @__PURE__ */ a(
      At,
      {
        toggleIcon: /* @__PURE__ */ a(Ve, {}),
        breakpoint: t,
        visibility: { default: "visible", [t]: "hidden" },
        children: /* @__PURE__ */ f(Pt, { variant: "filter-group", children: [
          s.length > 1 && /* @__PURE__ */ a(
            ze,
            {
              options: s,
              value: i,
              onChange: r,
              ouiaId: "chip-filter-selector-small-viewport"
            }
          ),
          Object.entries(e).map(([c, o], l) => /* @__PURE__ */ a(
            Ot,
            {
              chips: o.type === "checkbox" ? o.chips.map((d) => ({ key: d, node: o.options[d] })) : o.chips,
              deleteChip: (d, h) => o.onRemoveChip(typeof h == "string" ? h : h.key),
              deleteChipGroup: o.onRemoveGroup,
              categoryName: c,
              showToolbarItem: c === i,
              children: c === i && n(c, o)
            },
            l
          ))
        ] })
      }
    )
  ] });
}
export {
  ai as AppAboutModal,
  ni as ApplicationAuth,
  Kt as AuthConfigContext,
  Ds as BasicAuthModal,
  ui as ChipFilter,
  ye as DateTime,
  dt as DeletableRow,
  Ks as FilterCheckbox,
  Ws as FilterSearch,
  ze as FilterSelector,
  Ys as FromNow,
  A as If,
  oi as IfAuth,
  Zs as IfNotEmpty,
  oe as IfNotLoading,
  ei as ListWithToolbar,
  di as Loading,
  ti as ObjectDropdown,
  si as ObjectSelect,
  hi as Pagination,
  ci as PleaseWaitModal,
  li as ProgressModal,
  gi as ResponsiveTable,
  ke as ResponsiveTd,
  lt as ResponsiveTh,
  $s as TableSkeleton,
  ii as ToggleIcon,
  ri as UrlUpload,
  at as useAuth
};
